/* Generated by GOB (v2.0.12)   (do not edit directly) */



/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>


#include <time.h>
#include <pan/base/pstring.h>
#include <pan/base/group.h>
#include <pan/base/message-source.h>
#include <pan/base/status-item.h>

#ifndef __ARTICLE_H__
#define __ARTICLE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



enum {
	DECODE_STATE_NONE	= 0,
	DECODE_STATE_DECODED	= 1,
	DECODE_STATE_FAILED	= 2
};

enum {
	MULTIPART_STATE_NONE    = 0,
	MULTIPART_STATE_SOME    = 1,
	MULTIPART_STATE_ALL     = 2
};

typedef enum
{
	GET_WHOLE_THREAD,
	GET_SUBTHREAD
}
ThreadGet;

#ifndef __TYPEDEF_ARTICLE__
#define __TYPEDEF_ARTICLE__
typedef struct _Article Article;
#endif

typedef void (*ArticleForeach)(Article * article, gpointer user_data);
typedef void (*ArticleForall)(GPtrArray *articles, gpointer user_data);


/*
 * Type checking and casting macros
 */
#define TYPE_ARTICLE	(article_get_type())
#define ARTICLE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), article_get_type(), Article)
#define ARTICLE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), article_get_type(), Article const)
#define ARTICLE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), article_get_type(), ArticleClass)
#define IS_ARTICLE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), article_get_type ())

#define ARTICLE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), article_get_type(), ArticleClass)

/* Private structure type */
typedef struct _ArticlePrivate ArticlePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_ARTICLE__
#define __TYPEDEF_ARTICLE__
typedef struct _Article Article;
#endif
struct _Article {
	GObject __parent__;
	/*< public >*/
	gint64 id;
	guint8 multipart_state;
	guint16 parts;
	guint8 decode_state;
	guint16 line_qty;
	gulong byte_qty;
	time_t date;
	gboolean passes_filter;
	gint16 subthread_score;
	gint32 new_children;
	gint32 unread_children;
	/*< private >*/
	ArticlePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _ArticleClass ArticleClass;
struct _ArticleClass {
	GObjectClass __parent__;
};


/*
 * Public methods
 */
GType	article_get_type	(void);
Article * 	article_new	(gint64 id);
Article * 	article_get_by_id	(gint64 id);
gboolean 	article_is_new	(Article const * self);
void 	article_set_old	(Article * self);
gboolean 	article_is_read	(Article const * self);
void 	article_set_read	(Article * self,
					gboolean read);
void 	article_set_read_simple	(Article * self,
					gboolean read);
gboolean 	article_is_flagged	(Article const * self);
void 	article_set_flagged	(Article * self,
					gboolean flagged);
gboolean 	article_is_cached	(Article const * self);
int 	article_get_subject	(Article const * self,
					char * buf,
					int len);
gint16 	article_get_score	(Article const * self,
					gint32 group_id);
gint32 	article_get_score_date	(Article const * self,
					gint32 group_id);
void 	article_set_score	(Article * self,
					int score,
					gint32 score_date,
					gint32 group_id);
char * 	article_get_message_id	(Article const * self,
					char * buf,
					int len);
int 	article_get_decode_state	(Article const * self);
void 	article_set_decode_state	(Article * self,
					int state);
int 	article_get_multipart_state	(Article const * self);
void 	article_set_multipart_state	(Article * self,
					int state);
void 	article_set_error_flag	(Article * self,
					gboolean flag);
gboolean 	article_get_error_flag	(Article const * self);
char * 	article_format_author_str	(const PString * author_addr,
					const PString * author_real,
					char * buf,
					int bufsize);
char * 	article_get_author_str	(Article const * self,
					char * buf,
					int bufsize);
int 	article_format_short_author_str	(const PString * author_addr,
					const PString * author_real,
					char * buf,
					int bufsize);
int 	article_get_short_author_str	(Article const * self,
					char * buf,
					int bufsize);
char * 	article_get_author_real	(Article const * self,
					char * buf,
					int bufsize);
char * 	article_get_author_addr	(Article const * self,
					char * buf,
					int bufsize);
char * 	article_get_hash	(Article const * self);
GSList * 	article_load_articles	(Group * group,
					gint64 parent,
					StatusItem * status);
GSList * 	article_get_children	(Article const * self,
					const Group * group);
guint 	article_get_num_children	(Article const * self,
					const Group * group);
int 	article_get_num_parts	(Article const * self);
void 	article_delete	(Article * self);
void 	article_delete_by_msg_id	(const PString * msg_id);
GSList * 	article_get_header	(Article const * self,
					const char * header);
GPtrArray * 	article_get_parts	(Article const * self);
GPtrArray * 	article_get_parts_weed_duplicates	(Article const * self);
GArray * 	article_get_part_nums	(Article const * self);
GArray * 	article_get_missing_part_nums	(Article const * self);
void 	article_get_sources	(Article const * self,
					MessageSources * fillme);
Article * 	article_get_parent	(Article const * self,
					const Group * group);
gboolean 	article_same_author	(Article const * self,
					const Article * other);
gboolean 	article_subjects_are_similar	(Article const * self,
					const Article * other);
GPtrArray * 	article_get_servers	(Article const * self);
Article * 	article_get_root	(Article const * self);
void 	article_get_thread_message_id	(Article const * self,
					char * buf,
					gint len);


gboolean article_header_is_internal(const char* name);
gboolean article_header_is_extra(const char* name);
void articles_set_decode_state(Article ** articles, int qty, int state);
void articles_set_multipart_state(Article ** articles, int qty, int state);
gboolean articles_are_in_same_thread(const Article *a , const Article *b );
void articles_set_old(Article **articles, guint qty);
void articles_get_roots(GPtrArray *articles, GPtrArray *setme);
void articles_set_read(Article**articles, guint qty, gboolean read);



	/* Headers stored in their own fields but here for completeness */
#define HEADER_REFERENCES         "References"
#define HEADER_SUBJECT            "Subject"
#define HEADER_FROM               "From"
#define HEADER_MESSAGE_ID         "Message-Id"
#define HEADER_DATE               "Date"
#define HEADER_XREF               "Xref"
/* Headers not stored (must be retrieved from the body). */
#define HEADER_TO                 "To"
#define HEADER_ORGANIZATION       "Organization"
#define HEADER_SUPERSEDES         "Supersedes"
#define HEADER_FOLLOWUP_TO        "Followup-To"
#define HEADER_NEWSGROUPS         "Newsgroups"
#define HEADER_REPLY_TO           "Reply-To"
#define HEADER_USER_AGENT         "User-Agent"
#define HEADER_X_NEWSREADER       "X-Newsreader"
#define HEADER_X_MAILER           "X-Mailer"
#define HEADER_X_FACE             "X-Face"
/* Headers beginning with X-Pan- are for internal use. */
#define PAN_ATTRIBUTION           "X-Pan-Internal-Attribution"
#define PAN_ATTACH_FILE           "X-Pan-Internal-Attach-File"
#define PAN_SERVER                "X-Pan-Internal-Post-Server"
#define PAN_LINES_PER_PART        "X-Pan-Internal-Lines-Per-Part"
#define PAN_CHARSET               "X-Pan-Internal-CharSet"
#define PAN_NEWSGROUPS            "X-Pan-Internal-Sendlater-Newsgroups"
#define PAN_TO                    "X-Pan-Internal-Sendlater-To"
#define PAN_NO_MESSAGE_ID         "X-Pan-Internal-No-Message-Id"


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
