#ifndef DB_ADD_H
#define DB_ADD_H

#include <glib.h>
#include <time.h>
#include <pan/base/pstring.h>
#include <pan/base/status-item.h>

typedef struct
{
	gulong uid;
	time_t date;
	gint byte_qty;
	gint lines;
	PString subject;
	PString author;
	PString msg_id;
	PString refs;
	PString xref;
} article_add_s;

typedef struct
{
	PString name;
	PString description;
	char permision;
} group_add_s;

gint64 add_article(gint32 gid, gint32 sid, const article_add_s *article);

GArray* add_articles(gint32 gid, gint32 sid, const article_add_s **articles, int qty, StatusItem *status);

void add_group(const group_add_s *group, gint32 sid);

void add_groups(const group_add_s **groups, int qty, gint32 sid);

void remove_group(gint32 gid, gint32 sid);

gint32 add_folder(const group_add_s *group);

#endif
