/* Generated by GOB (v2.0.12)   (do not edit directly) */



/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>


#include <pan/base/pstring.h>
#include <pan/base/status-item.h>

#include <gmime/gmime.h>


#ifndef __GROUP_H__
#define __GROUP_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#ifndef __TYPEDEF_SERVER__
#define __TYPEDEF_SERVER__
typedef struct _Server Server;
#endif
#ifndef __TYPEDEF_ARTICLE__
#define __TYPEDEF_ARTICLE__
typedef struct _Article Article;
#endif

typedef enum
{
	FILTER_SHOW_MATCHES                     = 5,
	FILTER_SHOW_SUBTHREADS                  = 6,
	FILTER_SHOW_THREAD                      = 7
}
FilterShow;

enum
{
	STATE_FILTER_NEW                   = (1<<0),
        STATE_FILTER_UNREAD                = (1<<1),
	STATE_FILTER_READ                  = (1<<2),
        STATE_FILTER_COMPLETE_BINARIES     = (1<<3),
        STATE_FILTER_INCOMPLETE_BINARIES   = (1<<4),
        STATE_FILTER_NONBINARIES           = (1<<5),
	STATE_FILTER_CACHED                = (1<<6),
	STATE_FILTER_NOT_CACHED            = (1<<7),
	STATE_FILTER_MINE                  = (1<<8),
	STATE_FILTER_NOT_MINE              = (1<<9),

        STATE_FILTER_SCORE_WATCHED         = (1<<10),
        STATE_FILTER_SCORE_HIGH            = (1<<11),
        STATE_FILTER_SCORE_MEDIUM          = (1<<12),
        STATE_FILTER_SCORE_ZERO            = (1<<13),
	STATE_FILTER_SCORE_LOW             = (1<<14),
	STATE_FILTER_SCORE_IGNORED         = (1<<15),
	STATE_FILTER_SCORE_MASK            = (STATE_FILTER_SCORE_WATCHED
	                                     | STATE_FILTER_SCORE_HIGH
	                                     | STATE_FILTER_SCORE_MEDIUM
	                                     | STATE_FILTER_SCORE_ZERO
	                                     | STATE_FILTER_SCORE_LOW
	                                     | STATE_FILTER_SCORE_IGNORED),
        STATE_FILTER_SAVED                 = (1<<16)
};

GQuark PAN_SENT(void);
GQuark PAN_SENDLATER(void);


/*
 * Type checking and casting macros
 */
#define TYPE_GROUP	(group_get_type())
#define GROUP(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), group_get_type(), Group)
#define GROUP_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), group_get_type(), Group const)
#define GROUP_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), group_get_type(), GroupClass)
#define IS_GROUP(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), group_get_type ())

#define GROUP_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), group_get_type(), GroupClass)

/* Private structure type */
typedef struct _GroupPrivate GroupPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GROUP__
#define __TYPEDEF_GROUP__
typedef struct _Group Group;
#endif
struct _Group {
	GObject __parent__;
	/*< public >*/
	guint32 id;
	guint8 old_sort_style;
	guint8 new_sort_style;
	guint32 filter_show;
	guint32 filter_bits;
	gint32 article_qty;
	gint32 article_read_qty;
	char * filter_name;
	GQuark quark;
	/*< private >*/
	GroupPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GroupClass GroupClass;
struct _GroupClass {
	GObjectClass __parent__;
	/*signal*/void (* headers_retrieved) (Group * self);
};


/*
 * Public methods
 */
GType	group_get_type	(void);
void 	group_headers_retrieved	(Group * self);
Group * 	group_new	(guint32 id);
Group * 	group_new_by_name	(const gchar * name);
const PString * 	group_get_name	(Group const * self);
const PString * 	group_get_collapsed_name	(Group const * self);
const char * 	group_get_raw_name	(Group const * self);
const char * 	group_get_acache_key	(Group const * self);
const char * 	group_get_description	(Group const * self);
gboolean 	group_is_subscribed	(Group const * self);
gboolean 	group_is_folder	(Group const * self);
gboolean 	group_is_group	(Group const * self);
gboolean 	group_is_moderated	(Group const * self);
gboolean 	group_is_read_only	(Group const * self);
gboolean 	group_is_new	(Group const * self);
const char * 	group_get_identity	(Group const * self);
void 	group_set_identity	(Group * self,
					const char * identity);
gboolean 	group_loaded_since_fetch	(Group const * self);
void 	group_set_loaded_since_fetch	(Group * self,
					gboolean loaded);
void 	group_update_counts	(Group * self);
void 	group_inc_read	(Group * self,
					int cnt);
void 	group_set_dirty	(Group * self);
GPtrArray * 	group_get_all_articles	(Group * self,
					StatusItem * status);
char * 	group_get_download_dir	(Group const * self);
void 	group_set_download_dir	(Group * self,
					const char * dir);
const char * 	group_get_default_charset	(Group const * self);
void 	group_set_default_charset	(Group * self,
					const char * charset);
void 	group_expire_articles_not_in_range	(Group * self,
					Server * server,
					gint32 low,
					gint32 high);
GPtrArray * 	group_get_servers	(Group const * self);
void 	group_delete_articles	(Group * self,
					Article ** articles,
					gint qty);
gulong 	group_get_article_high	(Group const * self,
					const Server * server);
gulong 	group_get_article_low	(Group const * self,
					const Server * server);
void 	group_mark_all_read	(Group * self,
					gboolean read);
void 	group_empty	(Group * self);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define group_connect__headers_retrieved(object,func,data)	g_signal_connect(GROUP(__extension__ ({Group *___object = (object); ___object; })),"headers_retrieved",(GCallback) __extension__ ({void (* ___headers_retrieved) (Group * ___fake___self, gpointer ___data ) = (func); ___headers_retrieved; }), (data))
#define group_connect_after__headers_retrieved(object,func,data)	g_signal_connect_after(GROUP(__extension__ ({Group *___object = (object); ___object; })),"headers_retrieved",(GCallback) __extension__ ({void (* ___headers_retrieved) (Group * ___fake___self, gpointer ___data ) = (func); ___headers_retrieved; }), (data))
#define group_connect_data__headers_retrieved(object,func,data,destroy_data,flags)	g_signal_connect_data(GROUP(__extension__ ({Group *___object = (object); ___object; })),"headers_retrieved",(GCallback) __extension__ ({void (* ___headers_retrieved) (Group * ___fake___self, gpointer ___data ) = (func); ___headers_retrieved; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define group_connect__headers_retrieved(object,func,data)	g_signal_connect(GROUP(object),"headers_retrieved",(GCallback)(func),(data))
#define group_connect_after__headers_retrieved(object,func,data)	g_signal_connect_after(GROUP(object),"headers_retrieved",(GCallback)(func),(data))
#define group_connect_data__headers_retrieved(object,func,data,destroy_data,flags)	g_signal_connect_data(GROUP(object),"headers_retrieved",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */



void folder_add_message(Group *folder, GMimeMessage *message);
void folder_add_remove(Group *folder, GMimeMessage *message);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
