/* Generated by GOB (v2.0.12)   (do not edit directly) */



/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __FILTER_PHRASE_H__
#define __FILTER_PHRASE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <pan/filters/filter.h>

typedef enum
{
	PHRASE_KEY_SUBJECT              = 1,
	PHRASE_KEY_AUTHOR               = 2,
	PHRASE_KEY_MESSAGE_ID           = 3,
	PHRASE_KEY_REFERENCES           = 4,
	PHRASE_KEY_XREF                 = 5,
}
PhraseKeyType;

typedef enum
{
	PHRASE_MATCH_CONTAINS           = 1,
	PHRASE_MATCH_IS	                = 2,
	PHRASE_MATCH_STARTS_WITH        = 3,
	PHRASE_MATCH_ENDS_WITH          = 4,
	PHRASE_MATCH_REGEX              = 5 
}
PhraseMatchType;

enum
{
	REGEX_NEED_COMPILE,
	REGEX_ERR,
	REGEX_COMPILED
};

typedef struct _PcreInfo PcreInfo;


/*
 * Type checking and casting macros
 */
#define TYPE_FILTER_PHRASE	(filter_phrase_get_type())
#define FILTER_PHRASE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), filter_phrase_get_type(), FilterPhrase)
#define FILTER_PHRASE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), filter_phrase_get_type(), FilterPhrase const)
#define FILTER_PHRASE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), filter_phrase_get_type(), FilterPhraseClass)
#define IS_FILTER_PHRASE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), filter_phrase_get_type ())

#define FILTER_PHRASE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), filter_phrase_get_type(), FilterPhraseClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_FILTER_PHRASE__
#define __TYPEDEF_FILTER_PHRASE__
typedef struct _FilterPhrase FilterPhrase;
#endif
struct _FilterPhrase {
	Filter __parent__;
	/*< public >*/
	PhraseMatchType public_match_type;
	PhraseMatchType match_type;
	PhraseKeyType key_type;
	char * public_key;
	char * private_key;
	int private_key_len;
	char bmhs_skip[UCHAR_MAX];
	PcreInfo * pcre_info;
	int pcre_state;
	gboolean case_sensitive;
};

/*
 * Class definition
 */
typedef struct _FilterPhraseClass FilterPhraseClass;
struct _FilterPhraseClass {
	FilterClass __parent__;
};


/*
 * Public methods
 */
GType	filter_phrase_get_type	(void);
Filter * 	filter_phrase_new	(void);
void 	filter_phrase_set	(FilterPhrase * self,
					PhraseMatchType match_type,
					PhraseKeyType key_type,
					const char * key,
					gboolean case_sensitive);
gboolean 	filter_phrase_does_match	(FilterPhrase * self,
					const char * text,
					int text_len);
char * 	filter_phrase_create_regex	(const char * string,
					PhraseMatchType match_type);
char * 	filter_phrase_validate_pattern	(const char * pattern);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
