/* Generated by GOB (v2.0.12) on Fri Oct 07 00:43:20 2005
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */


#line 2 "pan/pan/queue.gob"

/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#line 29 "queue.c"
#define GOB_VERSION_MAJOR 2
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 12

#define selfp (self->_priv)

#include <string.h> /* memset() */

#include "queue.h"

#ifdef G_LIKELY
#define ___GOB_LIKELY(expr) G_LIKELY(expr)
#define ___GOB_UNLIKELY(expr) G_UNLIKELY(expr)
#else /* ! G_LIKELY */
#define ___GOB_LIKELY(expr) (expr)
#define ___GOB_UNLIKELY(expr) (expr)
#endif /* G_LIKELY */

#line 35 "pan/pan/queue.gob"

#include <config.h>

#include <errno.h>

#include <glib.h>
#include <glib/gi18n-lib.h>

#include <pan/base/base-prefs.h>
#include <pan/base/debug.h>
#include <pan/base/log.h>
#include <pan/base/server.h>

#include <pan/socket-pool.h>
#include <pan/task-xml.h>

#line 65 "queue.c"
static const GEnumValue _queue_task_status_values[] = {
	{ QUEUE_TASK_STATUS_NOT_QUEUED, (char *)"QUEUE_TASK_STATUS_NOT_QUEUED", (char *)"not-queued" },
	{ QUEUE_TASK_STATUS_QUEUED, (char *)"QUEUE_TASK_STATUS_QUEUED", (char *)"queued" },
	{ QUEUE_TASK_STATUS_RUNNING, (char *)"QUEUE_TASK_STATUS_RUNNING", (char *)"running" },
	{ QUEUE_TASK_STATUS_STOPPING, (char *)"QUEUE_TASK_STATUS_STOPPING", (char *)"stopping" },
	{ QUEUE_TASK_STATUS_STOPPED, (char *)"QUEUE_TASK_STATUS_STOPPED", (char *)"stopped" },
	{ QUEUE_TASK_STATUS_REMOVING, (char *)"QUEUE_TASK_STATUS_REMOVING", (char *)"removing" },
	{ 0, NULL, NULL }
};

GType
queue_task_status_get_type (void)
{
	static GType type = 0;
	if ___GOB_UNLIKELY(type == 0)
		type = g_enum_register_static ("QueueTaskStatus", _queue_task_status_values);
	return type;
}

static const GEnumValue _queue_enum_values[] = {
	{ QUEUE_MESSAGE_ID_DOWNLOAD, (char *)"QUEUE_MESSAGE_ID_DOWNLOAD", (char *)"message-id-download" },
	{ QUEUE_MESSAGE_ID_SAVE, (char *)"QUEUE_MESSAGE_ID_SAVE", (char *)"message-id-save" },
	{ 0, NULL, NULL }
};

GType
queue_enum_get_type (void)
{
	static GType type = 0;
	if ___GOB_UNLIKELY(type == 0)
		type = g_enum_register_static ("QueueEnum", _queue_enum_values);
	return type;
}


#line 66 "pan/pan/queue.gob"

/***********
************  Private
***********/

static GSList* task_list = NULL;

static GHashTable * server_to_pool = NULL;
static GHashTable * task_to_status = NULL;
static GHashTable * article_hash = NULL;

static guint running_tasks = 0;

static gboolean _online = TRUE;
static gboolean _remove_failed_tasks = TRUE;
static gboolean _dirty = FALSE;

static guint queue_upkeep_timer_id = 0u;

/*********************
**********************  BEGINNING OF SOURCE
*********************/

#define SECONDS_BETWEEN_QUEUE_UPKEEP 15

static Queue *_gq=NULL;
static guint queue_quick_timer_id = 0;


#line 131 "queue.c"

#line 96 "pan/pan/queue.gob"

/***
**** SOCKET POOL
***/

static void
pool_count_ghfunc(gpointer key,
                   gpointer value,
                   gpointer user_data)
{
	int * pi = (int *) user_data;
	const SocketPool * pool = (const SocketPool*) value;
	(*pi) += socket_pool_get_connection_qty(pool);
}

static void queue_connection_size_changed(Queue*, gint increment);

static void
pool_socket_avail_cb(SocketPool * call_object,
                      Server* call_arg,
                      gpointer user_data)
{
	/* update the connection count */
	int qty = 0;
	g_hash_table_foreach(server_to_pool, pool_count_ghfunc, &qty);
	queue_connection_size_changed(queue_get(),qty);

	/* wakeup the queue */
	queue_wakeup();
}

static SocketPool*
get_socket_pool_from_server(Server * server)
{
	SocketPool * pool =
		(SocketPool*) g_hash_table_lookup(server_to_pool, server);
	if (pool == NULL) {
		pool = socket_pool_new(server);
		socket_pool_set_online(pool, _online);
		socket_pool_connect__connection_available_changed(pool,pool_socket_avail_cb,NULL);
		g_hash_table_insert(server_to_pool, server, pool);
	}
	return pool;
}

#line 179 "queue.c"

#line 142 "pan/pan/queue.gob"

/************
*************  PRIVATE ROUTINES
************/

/***
****
***/
static void queue_size_changed(Queue*, guint running_qty, guint total_qty);
static void
increment_running_task_qty(int inc)
{
	running_tasks += inc;
	//fire_queue_size_changed (running_tasks, g_slist_length(task_list));
	queue_size_changed(queue_get(),running_tasks,g_slist_length(task_list));
}

static void queue_set_task_status(Task*, QueueTaskStatus);

static void
inc_task_work(Task * task)
{
	if (++task->thread_qty == 1)
	{
		/* This is mostly for the benefit of the GUI */
		queue_set_task_status(task, QUEUE_TASK_STATUS_RUNNING);
		status_item_set_active(STATUS_ITEM(task), TRUE);
		increment_running_task_qty(1);
	}
}

static void
dec_task_work (Task * task)
{
	if (!--task->thread_qty)
	{
		GSList * l;
		const QueueTaskStatus qts = queue_get_task_status(task);

		/* let the GUI know what's going on */
		status_item_set_active(STATUS_ITEM(task), FALSE);
		increment_running_task_qty(-1);

		/* if the task is slated for removal or stopping,
		 * the queue is waiting for the task's threads to finish. */
		switch (qts) {
			case QUEUE_TASK_STATUS_REMOVING:
				l = g_slist_append (NULL, task);
				queue_remove_tasks (l);
				g_slist_free (l);
				break;
			case QUEUE_TASK_STATUS_STOPPING:
				l = g_slist_append (NULL, task);
				queue_stop_tasks (l);
				g_slist_free (l);
				break;
			default:
				queue_set_task_status (
					task, QUEUE_TASK_STATUS_QUEUED);
				break;
		}
	}
}


#line 247 "queue.c"
/* self casting macros */
#define SELF(x) QUEUE(x)
#define SELF_CONST(x) QUEUE_CONST(x)
#define IS_SELF(x) IS_QUEUE(x)
#define TYPE_SELF TYPE_QUEUE
#define SELF_CLASS(x) QUEUE_CLASS(x)

#define SELF_GET_CLASS(x) QUEUE_GET_CLASS(x)

/* self typedefs */
typedef Queue Self;
typedef QueueClass SelfClass;

/* here are local prototypes */
static void queue_init (Queue * o) G_GNUC_UNUSED;
static void queue_class_init (QueueClass * c) G_GNUC_UNUSED;
static void queue_size_changed (Queue * self, guint running_qty, guint total_qty) G_GNUC_UNUSED;
static void queue_connection_size_changed (Queue * self, gint increment) G_GNUC_UNUSED;
static void queue_article_status_changed (Queue * self, const Article ** articles, gint article_qty) G_GNUC_UNUSED;
static void queue_online_status_changed (Queue * self, gboolean online) G_GNUC_UNUSED;
static void queue_tasks_added (Queue * self, GSList * new_tasks, gint position_in_queue) G_GNUC_UNUSED;
static void queue_tasks_removed (Queue * self, GSList * tasks) G_GNUC_UNUSED;
static void queue_tasks_moved (Queue * self, GSList * tasks, gint new_start_index) G_GNUC_UNUSED;
static void queue_set_online_ghfunc (gpointer key, gpointer value, gpointer user_data) G_GNUC_UNUSED;
static void queue_set_task_status (Task * task, QueueTaskStatus status) G_GNUC_UNUSED;
static void queue_add_article_state (const Article ** arts, int art_qty, int state) G_GNUC_UNUSED;
static void queue_remove_article_state (const Article ** arts, int art_qty, int state) G_GNUC_UNUSED;
static int queue_task_get_type_state (const Task * task) G_GNUC_UNUSED;
static void queue_add_articles_forall_func (Task * task, Article ** arts, int art_qty, gpointer state_gpointer) G_GNUC_UNUSED;
static void queue_add_articles (Task * task) G_GNUC_UNUSED;
static void queue_remove_articles_forall_func (Task * task, Article ** arts, int art_qty, gpointer state_gpointer) G_GNUC_UNUSED;
static void queue_remove_articles (Task * task) G_GNUC_UNUSED;
static void queue_save_tasks_forall (Task ** tasks, int task_qty, gpointer filename_gpointer) G_GNUC_UNUSED;
static void queue_task_work (Task * task) G_GNUC_UNUSED;
static void queue_task_checkin_channel (Task * task, GIOChannel * channel, gboolean channel_ok, gpointer user_data) G_GNUC_UNUSED;
static void queue_task_give_socket (Task * task, GIOChannel * channel) G_GNUC_UNUSED;
static void queue_run_tasks_foreach (gpointer task_gpointer, gpointer user_data) G_GNUC_UNUSED;
static gboolean queue_upkeep (gpointer do_loop) G_GNUC_UNUSED;

/*
 * Signal connection wrapper macro shortcuts
 */
#define self_connect__size_changed(object,func,data)	queue_connect__size_changed((object),(func),(data))
#define self_connect_after__size_changed(object,func,data)	queue_connect_after__size_changed((object),(func),(data))
#define self_connect_data__size_changed(object,func,data,destroy_data,flags)	queue_connect_data__size_changed((object),(func),(data),(destroy_data),(flags))
#define self_connect__connection_size_changed(object,func,data)	queue_connect__connection_size_changed((object),(func),(data))
#define self_connect_after__connection_size_changed(object,func,data)	queue_connect_after__connection_size_changed((object),(func),(data))
#define self_connect_data__connection_size_changed(object,func,data,destroy_data,flags)	queue_connect_data__connection_size_changed((object),(func),(data),(destroy_data),(flags))
#define self_connect__article_status_changed(object,func,data)	queue_connect__article_status_changed((object),(func),(data))
#define self_connect_after__article_status_changed(object,func,data)	queue_connect_after__article_status_changed((object),(func),(data))
#define self_connect_data__article_status_changed(object,func,data,destroy_data,flags)	queue_connect_data__article_status_changed((object),(func),(data),(destroy_data),(flags))
#define self_connect__online_status_changed(object,func,data)	queue_connect__online_status_changed((object),(func),(data))
#define self_connect_after__online_status_changed(object,func,data)	queue_connect_after__online_status_changed((object),(func),(data))
#define self_connect_data__online_status_changed(object,func,data,destroy_data,flags)	queue_connect_data__online_status_changed((object),(func),(data),(destroy_data),(flags))
#define self_connect__tasks_added(object,func,data)	queue_connect__tasks_added((object),(func),(data))
#define self_connect_after__tasks_added(object,func,data)	queue_connect_after__tasks_added((object),(func),(data))
#define self_connect_data__tasks_added(object,func,data,destroy_data,flags)	queue_connect_data__tasks_added((object),(func),(data),(destroy_data),(flags))
#define self_connect__tasks_removed(object,func,data)	queue_connect__tasks_removed((object),(func),(data))
#define self_connect_after__tasks_removed(object,func,data)	queue_connect_after__tasks_removed((object),(func),(data))
#define self_connect_data__tasks_removed(object,func,data,destroy_data,flags)	queue_connect_data__tasks_removed((object),(func),(data),(destroy_data),(flags))
#define self_connect__tasks_moved(object,func,data)	queue_connect__tasks_moved((object),(func),(data))
#define self_connect_after__tasks_moved(object,func,data)	queue_connect_after__tasks_moved((object),(func),(data))
#define self_connect_data__tasks_moved(object,func,data,destroy_data,flags)	queue_connect_data__tasks_moved((object),(func),(data),(destroy_data),(flags))

typedef void  (*___Sig1) (Queue *, guint , guint , gpointer);

static void
___marshal_Sig1 (GClosure *closure,
	GValue *return_value G_GNUC_UNUSED,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint G_GNUC_UNUSED,
	gpointer marshal_data)
{
	register ___Sig1 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 3);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig1) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((Queue *)data1,
		(guint ) g_value_get_uint (param_values + 1),
		(guint ) g_value_get_uint (param_values + 2),
		data2);
}


typedef void  (*___Sig2) (Queue *, gint , gpointer);

static void
___marshal_Sig2 (GClosure *closure,
	GValue *return_value G_GNUC_UNUSED,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint G_GNUC_UNUSED,
	gpointer marshal_data)
{
	register ___Sig2 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 2);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig2) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((Queue *)data1,
		(gint ) g_value_get_int (param_values + 1),
		data2);
}


typedef void  (*___Sig3) (Queue *, gpointer , gint , gpointer);

static void
___marshal_Sig3 (GClosure *closure,
	GValue *return_value G_GNUC_UNUSED,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint G_GNUC_UNUSED,
	gpointer marshal_data)
{
	register ___Sig3 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 3);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig3) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((Queue *)data1,
		(gpointer ) g_value_get_pointer (param_values + 1),
		(gint ) g_value_get_int (param_values + 2),
		data2);
}


typedef void  (*___Sig4) (Queue *, gboolean , gpointer);

static void
___marshal_Sig4 (GClosure *closure,
	GValue *return_value G_GNUC_UNUSED,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint G_GNUC_UNUSED,
	gpointer marshal_data)
{
	register ___Sig4 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 2);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig4) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((Queue *)data1,
		(gboolean ) g_value_get_boolean (param_values + 1),
		data2);
}


typedef void  (*___Sig5) (Queue *, gpointer , gpointer);

static void
___marshal_Sig5 (GClosure *closure,
	GValue *return_value G_GNUC_UNUSED,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint G_GNUC_UNUSED,
	gpointer marshal_data)
{
	register ___Sig5 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 2);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig5) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((Queue *)data1,
		(gpointer ) g_value_get_pointer (param_values + 1),
		data2);
}


enum {
	SIZE_CHANGED_SIGNAL,
	CONNECTION_SIZE_CHANGED_SIGNAL,
	ARTICLE_STATUS_CHANGED_SIGNAL,
	ONLINE_STATUS_CHANGED_SIGNAL,
	TASKS_ADDED_SIGNAL,
	TASKS_REMOVED_SIGNAL,
	TASKS_MOVED_SIGNAL,
	LAST_SIGNAL
};

static guint object_signals[LAST_SIGNAL] = {0};

/* pointer to the class of our parent */
static GObjectClass *parent_class = NULL;

/* Short form macros */
#define self_size_changed queue_size_changed
#define self_connection_size_changed queue_connection_size_changed
#define self_article_status_changed queue_article_status_changed
#define self_online_status_changed queue_online_status_changed
#define self_tasks_added queue_tasks_added
#define self_tasks_removed queue_tasks_removed
#define self_tasks_moved queue_tasks_moved
#define self_startup queue_startup
#define self_shutdown queue_shutdown
#define self_get queue_get
#define self_add queue_add
#define self_set_online_ghfunc queue_set_online_ghfunc
#define self_set_online queue_set_online
#define self_is_online queue_is_online
#define self_get_article_status queue_get_article_status
#define self_forall_tasks queue_forall_tasks
#define self_is_empty queue_is_empty
#define self_insert_tasks queue_insert_tasks
#define self_stop_tasks queue_stop_tasks
#define self_remove_tasks queue_remove_tasks
#define self_remove_last_task queue_remove_last_task
#define self_move_tasks queue_move_tasks
#define self_requeue_failed_tasks queue_requeue_failed_tasks
#define self_get_remove_failed_tasks queue_get_remove_failed_tasks
#define self_set_remove_failed_tasks queue_set_remove_failed_tasks
#define self_wakeup queue_wakeup
#define self_get_task_status queue_get_task_status
#define self_set_task_status queue_set_task_status
#define self_get_tasks_filename queue_get_tasks_filename
#define self_add_article_state queue_add_article_state
#define self_remove_article_state queue_remove_article_state
#define self_task_get_type_state queue_task_get_type_state
#define self_add_articles_forall_func queue_add_articles_forall_func
#define self_add_articles queue_add_articles
#define self_remove_articles_forall_func queue_remove_articles_forall_func
#define self_remove_articles queue_remove_articles
#define self_save_tasks_forall queue_save_tasks_forall
#define self_task_work queue_task_work
#define self_task_checkin_channel queue_task_checkin_channel
#define self_task_give_socket queue_task_give_socket
#define self_run_tasks_foreach queue_run_tasks_foreach
#define self_upkeep queue_upkeep
GType
queue_get_type (void)
{
	static GType type = 0;

	if ___GOB_UNLIKELY(type == 0) {
		static const GTypeInfo info = {
			sizeof (QueueClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) queue_class_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			sizeof (Queue),
			0 /* n_preallocs */,
			(GInstanceInitFunc) queue_init,
			NULL
		};

		type = g_type_register_static (G_TYPE_OBJECT, "Queue", &info, (GTypeFlags)0);
	}

	return type;
}

/* a macro for creating a new object of our type */
#define GET_NEW ((Queue *)g_object_new(queue_get_type(), NULL))

/* a function for creating a new object of our type */
#include <stdarg.h>
static Queue * GET_NEW_VARG (const char *first, ...) G_GNUC_UNUSED;
static Queue *
GET_NEW_VARG (const char *first, ...)
{
	Queue *ret;
	va_list ap;
	va_start (ap, first);
	ret = (Queue *)g_object_new_valist (queue_get_type (), first, ap);
	va_end (ap);
	return ret;
}

static void 
queue_init (Queue * o G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Queue::init"
}
#undef __GOB_FUNCTION__
static void 
queue_class_init (QueueClass * c G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Queue::class_init"
	GObjectClass *g_object_class G_GNUC_UNUSED = (GObjectClass*) c;

	parent_class = g_type_class_ref (G_TYPE_OBJECT);

	object_signals[SIZE_CHANGED_SIGNAL] =
		g_signal_new ("size_changed",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, size_changed),
			NULL, NULL,
			___marshal_Sig1,
			G_TYPE_NONE, 2,
			G_TYPE_UINT,
			G_TYPE_UINT);
	if ___GOB_UNLIKELY(sizeof(guint ) != sizeof(guint ) || sizeof(guint ) != sizeof(guint ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 210: Type mismatch of \"size_changed\" signal signature");
	}
	object_signals[CONNECTION_SIZE_CHANGED_SIGNAL] =
		g_signal_new ("connection_size_changed",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, connection_size_changed),
			NULL, NULL,
			___marshal_Sig2,
			G_TYPE_NONE, 1,
			G_TYPE_INT);
	if ___GOB_UNLIKELY(sizeof(gint ) != sizeof(gint ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 213: Type mismatch of \"connection_size_changed\" signal signature");
	}
	object_signals[ARTICLE_STATUS_CHANGED_SIGNAL] =
		g_signal_new ("article_status_changed",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, article_status_changed),
			NULL, NULL,
			___marshal_Sig3,
			G_TYPE_NONE, 2,
			G_TYPE_POINTER,
			G_TYPE_INT);
	if ___GOB_UNLIKELY(sizeof(const Article ** ) != sizeof(gpointer ) || sizeof(gint ) != sizeof(gint ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 216: Type mismatch of \"article_status_changed\" signal signature");
	}
	object_signals[ONLINE_STATUS_CHANGED_SIGNAL] =
		g_signal_new ("online_status_changed",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, online_status_changed),
			NULL, NULL,
			___marshal_Sig4,
			G_TYPE_NONE, 1,
			G_TYPE_BOOLEAN);
	if ___GOB_UNLIKELY(sizeof(gboolean ) != sizeof(gboolean ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 219: Type mismatch of \"online_status_changed\" signal signature");
	}
	object_signals[TASKS_ADDED_SIGNAL] =
		g_signal_new ("tasks_added",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, tasks_added),
			NULL, NULL,
			___marshal_Sig3,
			G_TYPE_NONE, 2,
			G_TYPE_POINTER,
			G_TYPE_INT);
	if ___GOB_UNLIKELY(sizeof(GSList * ) != sizeof(gpointer ) || sizeof(gint ) != sizeof(gint ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 222: Type mismatch of \"tasks_added\" signal signature");
	}
	object_signals[TASKS_REMOVED_SIGNAL] =
		g_signal_new ("tasks_removed",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, tasks_removed),
			NULL, NULL,
			___marshal_Sig5,
			G_TYPE_NONE, 1,
			G_TYPE_POINTER);
	if ___GOB_UNLIKELY(sizeof(GSList * ) != sizeof(gpointer ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 225: Type mismatch of \"tasks_removed\" signal signature");
	}
	object_signals[TASKS_MOVED_SIGNAL] =
		g_signal_new ("tasks_moved",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST),
			G_STRUCT_OFFSET (QueueClass, tasks_moved),
			NULL, NULL,
			___marshal_Sig3,
			G_TYPE_NONE, 2,
			G_TYPE_POINTER,
			G_TYPE_INT);
	if ___GOB_UNLIKELY(sizeof(GSList * ) != sizeof(gpointer ) || sizeof(gint ) != sizeof(gint ) || parent_class == NULL /* avoid warning */) {
		g_error("pan/pan/queue.gob line 228: Type mismatch of \"tasks_moved\" signal signature");
	}

	c->size_changed = NULL;
	c->connection_size_changed = NULL;
	c->article_status_changed = NULL;
	c->online_status_changed = NULL;
	c->tasks_added = NULL;
	c->tasks_removed = NULL;
	c->tasks_moved = NULL;
}
#undef __GOB_FUNCTION__



#line 210 "pan/pan/queue.gob"
static void 
queue_size_changed (Queue * self, guint running_qty, guint total_qty)
#line 693 "queue.c"
{
	GValue ___param_values[3];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 210 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 210 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 705 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_UINT);
	g_value_set_uint (&___param_values[1], (guint ) running_qty);

	___param_values[2].g_type = 0;
	g_value_init (&___param_values[2], G_TYPE_UINT);
	g_value_set_uint (&___param_values[2], (guint ) total_qty);

	g_signal_emitv (___param_values,
		object_signals[SIZE_CHANGED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
	g_value_unset (&___param_values[2]);
}

#line 213 "pan/pan/queue.gob"
static void 
queue_connection_size_changed (Queue * self, gint increment)
#line 732 "queue.c"
{
	GValue ___param_values[2];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 213 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 213 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 744 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_INT);
	g_value_set_int (&___param_values[1], (gint ) increment);

	g_signal_emitv (___param_values,
		object_signals[CONNECTION_SIZE_CHANGED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}

#line 216 "pan/pan/queue.gob"
static void 
queue_article_status_changed (Queue * self, const Article ** articles, gint article_qty)
#line 766 "queue.c"
{
	GValue ___param_values[3];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 216 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 216 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 778 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_POINTER);
	g_value_set_pointer (&___param_values[1], (gpointer ) articles);

	___param_values[2].g_type = 0;
	g_value_init (&___param_values[2], G_TYPE_INT);
	g_value_set_int (&___param_values[2], (gint ) article_qty);

	g_signal_emitv (___param_values,
		object_signals[ARTICLE_STATUS_CHANGED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
	g_value_unset (&___param_values[2]);
}

#line 219 "pan/pan/queue.gob"
static void 
queue_online_status_changed (Queue * self, gboolean online)
#line 805 "queue.c"
{
	GValue ___param_values[2];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 219 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 219 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 817 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_BOOLEAN);
	g_value_set_boolean (&___param_values[1], (gboolean ) online);

	g_signal_emitv (___param_values,
		object_signals[ONLINE_STATUS_CHANGED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}

#line 222 "pan/pan/queue.gob"
static void 
queue_tasks_added (Queue * self, GSList * new_tasks, gint position_in_queue)
#line 839 "queue.c"
{
	GValue ___param_values[3];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 222 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 222 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 851 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_POINTER);
	g_value_set_pointer (&___param_values[1], (gpointer ) new_tasks);

	___param_values[2].g_type = 0;
	g_value_init (&___param_values[2], G_TYPE_INT);
	g_value_set_int (&___param_values[2], (gint ) position_in_queue);

	g_signal_emitv (___param_values,
		object_signals[TASKS_ADDED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
	g_value_unset (&___param_values[2]);
}

#line 225 "pan/pan/queue.gob"
static void 
queue_tasks_removed (Queue * self, GSList * tasks)
#line 878 "queue.c"
{
	GValue ___param_values[2];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 225 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 225 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 890 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_POINTER);
	g_value_set_pointer (&___param_values[1], (gpointer ) tasks);

	g_signal_emitv (___param_values,
		object_signals[TASKS_REMOVED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}

#line 228 "pan/pan/queue.gob"
static void 
queue_tasks_moved (Queue * self, GSList * tasks, gint new_start_index)
#line 912 "queue.c"
{
	GValue ___param_values[3];
	GValue ___return_val;

memset (&___return_val, 0, sizeof (___return_val));
memset (&___param_values, 0, sizeof (___param_values));

#line 228 "pan/pan/queue.gob"
	g_return_if_fail (self != NULL);
#line 228 "pan/pan/queue.gob"
	g_return_if_fail (IS_QUEUE (self));
#line 924 "queue.c"

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_POINTER);
	g_value_set_pointer (&___param_values[1], (gpointer ) tasks);

	___param_values[2].g_type = 0;
	g_value_init (&___param_values[2], G_TYPE_INT);
	g_value_set_int (&___param_values[2], (gint ) new_start_index);

	g_signal_emitv (___param_values,
		object_signals[TASKS_MOVED_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
	g_value_unset (&___param_values[2]);
}

#line 231 "pan/pan/queue.gob"
void 
queue_startup (gboolean online, gboolean remove_failed_tasks)
#line 951 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::startup"
{
#line 232 "pan/pan/queue.gob"
	
		guint msec;
		
		debug_enter("queue_startup");
		self_get();
		
		server_to_pool = g_hash_table_new(g_direct_hash, g_direct_equal);
		task_to_status = g_hash_table_new(g_direct_hash, g_direct_equal);
		article_hash = g_hash_table_new_full(g_direct_hash, g_direct_equal,
												 (GDestroyNotify)g_object_unref,
												 NULL);
		
		_online = online;
		
		_remove_failed_tasks = remove_failed_tasks;
		
		msec = SECONDS_BETWEEN_QUEUE_UPKEEP * 1000;
		queue_upkeep_timer_id = g_timeout_add(msec,
											   queue_upkeep,
											   GINT_TO_POINTER(1));
		
		debug_exit("queue_startup");
	}}
#line 979 "queue.c"
#undef __GOB_FUNCTION__

#line 256 "pan/pan/queue.gob"
void 
queue_shutdown (void)
#line 985 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::shutdown"
{
#line 257 "pan/pan/queue.gob"
	
		/* clear the status hashtable */
		g_hash_table_destroy(task_to_status);
		task_to_status = NULL;
	
		/* optionally save the tasks */
	
		/* unref the tasks */
	
		/* close the sockets */
		/* FIXME: need to clear the socket pools */
		g_hash_table_destroy(article_hash);
	}}
#line 1003 "queue.c"
#undef __GOB_FUNCTION__

#line 271 "pan/pan/queue.gob"
Queue * 
queue_get (void)
#line 1009 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::get"
{
#line 272 "pan/pan/queue.gob"
	
		if G_UNLIKELY(!_gq)
			_gq=GET_NEW;
		return _gq;
	}}
#line 1019 "queue.c"
#undef __GOB_FUNCTION__

#line 278 "pan/pan/queue.gob"
void 
queue_add (Task * task)
#line 1025 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::add"
#line 278 "pan/pan/queue.gob"
	g_return_if_fail (task != NULL);
#line 278 "pan/pan/queue.gob"
	g_return_if_fail (IS_TASK (task));
#line 1032 "queue.c"
{
#line 279 "pan/pan/queue.gob"
	
		GSList * l;
		
		l = g_slist_append(NULL, task);
		self_insert_tasks(l, task->high_priority ? 0 : -1);
		g_slist_free(l);
	}}
#line 1042 "queue.c"
#undef __GOB_FUNCTION__

#line 287 "pan/pan/queue.gob"
static void 
queue_set_online_ghfunc (gpointer key, gpointer value, gpointer user_data)
#line 1048 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::set_online_ghfunc"
{
#line 288 "pan/pan/queue.gob"
	
		socket_pool_set_online((SocketPool*)value, _online);
	}}
#line 1056 "queue.c"
#undef __GOB_FUNCTION__

#line 292 "pan/pan/queue.gob"
void 
queue_set_online (gboolean online)
#line 1062 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::set_online"
{
#line 293 "pan/pan/queue.gob"
	
		if (_online != online)
		{
			_online = online;
	
			/* set the socket pools offline */
			g_hash_table_foreach(server_to_pool,
								  self_set_online_ghfunc,
								  NULL);
	
			/* let listeners know */
			self_online_status_changed(self_get(),_online);
		}
	
		if (_online)
			self_wakeup();
	}}
#line 1084 "queue.c"
#undef __GOB_FUNCTION__

#line 311 "pan/pan/queue.gob"
gboolean 
queue_is_online (void)
#line 1090 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::is_online"
{
#line 312 "pan/pan/queue.gob"
	
		return _online;
	}}
#line 1098 "queue.c"
#undef __GOB_FUNCTION__

#line 316 "pan/pan/queue.gob"
int 
queue_get_article_status (const Article * article)
#line 1104 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::get_article_status"
{
#line 317 "pan/pan/queue.gob"
	
		return GPOINTER_TO_INT(g_hash_table_lookup(article_hash, article));
	}}
#line 1112 "queue.c"
#undef __GOB_FUNCTION__

#line 321 "pan/pan/queue.gob"
void 
queue_forall_tasks (QueueForallTaskFunc forall_func, gpointer forall_func_user_data, gboolean run_even_if_no_tasks)
#line 1118 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::forall_tasks"
{
#line 323 "pan/pan/queue.gob"
	
		int i;
		int task_qty;
		GSList * l;
		Task ** tasks;
	
		task_qty = g_slist_length(task_list);
		tasks = g_newa(Task*, task_qty);
		for (l=task_list, i=0; l!=NULL; l=l->next, ++i)
			tasks[i] = (Task*) l->data;
	
		if (task_qty>0 || run_even_if_no_tasks)
			(*forall_func)(tasks, task_qty, forall_func_user_data);
	}}
#line 1137 "queue.c"
#undef __GOB_FUNCTION__

#line 338 "pan/pan/queue.gob"
gboolean 
queue_is_empty (void)
#line 1143 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::is_empty"
{
#line 339 "pan/pan/queue.gob"
	
		return task_list == NULL;
	}}
#line 1151 "queue.c"
#undef __GOB_FUNCTION__

#line 343 "pan/pan/queue.gob"
void 
queue_insert_tasks (const GSList * tasks, gint index)
#line 1157 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::insert_tasks"
#line 343 "pan/pan/queue.gob"
	g_return_if_fail (tasks != NULL);
#line 1162 "queue.c"
{
#line 344 "pan/pan/queue.gob"
	
		const GSList * tmp;
		GSList * insertme;

		/* sanity clause */
		g_return_if_fail(index==-1 || (guint)index<=g_slist_length(task_list));
		
		debug_enter("queue_insert_tasks");
		debug1(DEBUG_QUEUE, "queue_insert_tasks: inserting at position %d", index);
	
	
		/* make our own GSList nodes for inserting */
		insertme = g_slist_copy((GSList*)tasks);
	
		/**
		***  Add to the list
		**/
		if (task_list == NULL) /* no previous list */
			task_list = insertme;
		else if (index == 0)
			task_list = g_slist_concat(insertme, task_list);
		else if (index == -1)
			task_list = g_slist_concat(task_list, insertme);
		else {
			GSList * nth = g_slist_nth(task_list, index);
			if (nth == NULL) { /* index out of range, append to end */
				index = g_slist_length(task_list);
				nth = g_slist_last(task_list);
			}
			g_slist_last(insertme)->next = nth->next;
			nth->next = insertme;
		}
	
		/**
		***  Mark the new tasks as queued
		**/
		for (tmp=tasks; tmp!=NULL; tmp=tmp->next)
		{
			Task * task = TASK(tmp->data);
			self_add_articles(task);
			g_hash_table_insert(task_to_status, task, GINT_TO_POINTER(QUEUE_TASK_STATUS_QUEUED));
		}
	
		/* we need this for fire_queue_size_changed */
		_dirty = TRUE;
	
		/* cleanup */
		self_size_changed(self_get(),running_tasks, g_slist_length(task_list));
		self_tasks_added(self_get(),tasks, index);
		self_wakeup();
		debug_exit("queue_insert_tasks");
	}}
#line 1217 "queue.c"
#undef __GOB_FUNCTION__

#line 397 "pan/pan/queue.gob"
void 
queue_stop_tasks (const GSList * tasks)
#line 1223 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::stop_tasks"
{
#line 398 "pan/pan/queue.gob"
	
		const GSList * l;
		for (l=tasks; l!=NULL; l=l->next)
		{
			Task * task = TASK(l->data);
			const QueueTaskStatus status = self_get_task_status(task);
	
			if (status == QUEUE_TASK_STATUS_RUNNING)
			{
				/* ask a running task to stop */
				task->abort_flag = TRUE;
				self_set_task_status(task, QUEUE_TASK_STATUS_STOPPING);
			}
			else
			{
				/* if the task was stopped because we went offline,
				   set it to queued instead of stopped. */
				self_set_task_status(task, task->abort_flag && !self_is_online()
						? QUEUE_TASK_STATUS_QUEUED
						: QUEUE_TASK_STATUS_STOPPED);
			}
		}
	}}
#line 1251 "queue.c"
#undef __GOB_FUNCTION__

#line 422 "pan/pan/queue.gob"
void 
queue_remove_tasks (const GSList * tasks)
#line 1257 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::remove_tasks"
#line 422 "pan/pan/queue.gob"
	g_return_if_fail (tasks != NULL);
#line 1262 "queue.c"
{
#line 423 "pan/pan/queue.gob"
	
		const GSList * l;
		GSList * removed = NULL;
		debug_enter("queue_remove_tasks");
	
		for (l=tasks; l!=NULL; l=l->next)
		{
			Task * task = TASK(l->data);
			const gboolean is_in_task_list = g_slist_find(task_list, task) != NULL;
	
			if (is_in_task_list)
			{
				const gboolean is_running = task->thread_qty > 0;
	
				if (!is_running) /* we can remove it straight away */
				{
					task_list = g_slist_remove(task_list, task);
					removed = g_slist_prepend(removed, task);
					_dirty = TRUE;
				}
				else /* try to abort it before removing.
									'abort' should cause queue_task_work() to fail,
						then desc_task_work() will call
					queue_remove_tasks() with the aborted task. */
				{
					task->abort_flag = TRUE;
					self_set_task_status(task, QUEUE_TASK_STATUS_REMOVING);
				}
			}
		}
	
		if (removed != NULL)
		{
			removed = g_slist_reverse(removed);
			self_size_changed(self_get(),running_tasks,
									 g_slist_length(task_list));
			self_tasks_removed(self_get(),removed);
	
			for (l=removed; l!=NULL; l=l->next)
			{
				Task * task = TASK(l->data);
	
				task_ran(task,task->state.health);
				g_hash_table_remove(task_to_status, task);
				self_remove_articles(task);
				g_object_unref(G_OBJECT(task));
			}
	
			g_slist_free(removed);
		}
	
		debug_exit("queue_remove_tasks");
	}}
#line 1318 "queue.c"
#undef __GOB_FUNCTION__

#line 477 "pan/pan/queue.gob"
void 
queue_remove_last_task (void)
#line 1324 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::remove_last_task"
{
#line 478 "pan/pan/queue.gob"
	
		GSList * last = g_slist_last(task_list);
		if (last != NULL)
		{
			Task * task = TASK(last->data);
			GSList * l = g_slist_append(NULL, task);
			self_remove_tasks(l);
			g_slist_free(l);
		}
	}}
#line 1339 "queue.c"
#undef __GOB_FUNCTION__

#line 489 "pan/pan/queue.gob"
void 
queue_move_tasks (GSList * tasks, gint index)
#line 1345 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::move_tasks"
#line 489 "pan/pan/queue.gob"
	g_return_if_fail (tasks != NULL);
#line 1350 "queue.c"
{
#line 490 "pan/pan/queue.gob"
	
		GSList * l;
		GSList * ref;
	
		/* sanity clause */
		g_return_if_fail(task_list!=NULL);
	
		/* find the point of reference */
		if (index == 0)
			ref = NULL;
		else
		{
			ref = g_slist_nth(task_list, index-1);
			while (ref != NULL)
			{
				if (g_slist_find((GSList*)tasks, ref->data) == NULL)
					break;
				ref = ref->next;
			}
			if (ref == NULL)
				ref = g_slist_last(task_list);
		}
	
		/* remove the tasks */
		for (l=(GSList*)tasks; l!=NULL; l=l->next)
			task_list = g_slist_remove(task_list, l->data);
	
		/* add them back in */
		l = g_slist_copy((GSList*)tasks);
		if (ref == NULL)
		{
			g_slist_last(l)->next = task_list;
			task_list = l;
			index = 0;
		}
		else
		{
			if (task_list != NULL)
			{
				g_slist_last(l)->next = ref->next;
				ref->next = l;
			}
			else
				task_list = l;	
			index = g_slist_index(task_list, tasks->data);
		}
	
		/* let everyone know */
		_dirty = TRUE;
		self_tasks_moved(self_get(),tasks, index);
		debug_exit("queue_move_tasks");
	}}
#line 1405 "queue.c"
#undef __GOB_FUNCTION__

#line 543 "pan/pan/queue.gob"
void 
queue_requeue_failed_tasks (const GSList * tasks)
#line 1411 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::requeue_failed_tasks"
{
#line 544 "pan/pan/queue.gob"
	
		const GSList * l;
		
		for (l=tasks; l!=NULL; l=l->next)
		{
			Task * task = TASK(l->data);
			if (self_get_task_status(task) == QUEUE_TASK_STATUS_STOPPED)
			{
				task->abort_flag = FALSE;
				task_state_set_health(&task->state, TASK_OK);
				self_set_task_status(task, QUEUE_TASK_STATUS_QUEUED);
			}
		}
	
		self_wakeup();
	}}
#line 1432 "queue.c"
#undef __GOB_FUNCTION__

#line 565 "pan/pan/queue.gob"
gboolean 
queue_get_remove_failed_tasks (void)
#line 1438 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::get_remove_failed_tasks"
{
#line 566 "pan/pan/queue.gob"
	
		return _remove_failed_tasks;
	}}
#line 1446 "queue.c"
#undef __GOB_FUNCTION__

#line 570 "pan/pan/queue.gob"
void 
queue_set_remove_failed_tasks (gboolean b)
#line 1452 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::set_remove_failed_tasks"
{
#line 571 "pan/pan/queue.gob"
	
		_remove_failed_tasks = b;
	}}
#line 1460 "queue.c"
#undef __GOB_FUNCTION__

#line 575 "pan/pan/queue.gob"
void 
queue_wakeup (void)
#line 1466 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::wakeup"
{
#line 576 "pan/pan/queue.gob"
	
		if (queue_quick_timer_id == 0u)
			queue_quick_timer_id = g_idle_add(self_upkeep, NULL);
	}}
#line 1475 "queue.c"
#undef __GOB_FUNCTION__

#line 585 "pan/pan/queue.gob"
QueueTaskStatus 
queue_get_task_status (const Task * task)
#line 1481 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::get_task_status"
#line 585 "pan/pan/queue.gob"
	g_return_val_if_fail (task != NULL, (QueueTaskStatus )0);
#line 585 "pan/pan/queue.gob"
	g_return_val_if_fail (IS_TASK (task), (QueueTaskStatus )0);
#line 1488 "queue.c"
{
#line 586 "pan/pan/queue.gob"
	
		QueueTaskStatus status = QUEUE_TASK_STATUS_NOT_QUEUED;
		
		if (task_to_status != NULL)
		{
			gpointer p = g_hash_table_lookup(task_to_status, task);
			if (p != NULL)
				status = GPOINTER_TO_INT(p);
		}
		
		return status;
	}}
#line 1503 "queue.c"
#undef __GOB_FUNCTION__

#line 599 "pan/pan/queue.gob"
static void 
queue_set_task_status (Task * task, QueueTaskStatus status)
#line 1509 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::set_task_status"
#line 599 "pan/pan/queue.gob"
	g_return_if_fail (task != NULL);
#line 599 "pan/pan/queue.gob"
	g_return_if_fail (IS_TASK (task));
#line 1516 "queue.c"
{
#line 600 "pan/pan/queue.gob"
	
		g_return_if_fail(g_slist_index(task_list, task) != -1);
	
		if (task_to_status != NULL)
			g_hash_table_insert(task_to_status,
								 task,
								 GINT_TO_POINTER(status));
	}}
#line 1527 "queue.c"
#undef __GOB_FUNCTION__

#line 609 "pan/pan/queue.gob"
char * 
queue_get_tasks_filename (void)
#line 1533 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::get_tasks_filename"
{
#line 610 "pan/pan/queue.gob"
	
		return g_build_filename( get_data_dir(), "tasks.xml", NULL);
	}}
#line 1541 "queue.c"
#undef __GOB_FUNCTION__

#line 614 "pan/pan/queue.gob"
static void 
queue_add_article_state (const Article ** arts, int art_qty, int state)
#line 1547 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::add_article_state"
#line 614 "pan/pan/queue.gob"
	g_return_if_fail (arts != NULL);
#line 614 "pan/pan/queue.gob"
	g_return_if_fail (art_qty > 0);
#line 614 "pan/pan/queue.gob"
	g_return_if_fail (state != 0);
#line 1556 "queue.c"
{
#line 615 "pan/pan/queue.gob"
	
		int i;
		
		/* sanity clause */
		g_return_if_fail(IS_ARTICLE(arts[0]));
		
		/* add the state */
		for (i=0; i<art_qty; ++i)
		{
			int new_state = state | self_get_article_status(arts[i]);
			g_object_ref(arts[i]);
			g_hash_table_insert(article_hash,
								 arts[i],
								 GINT_TO_POINTER(new_state));
		}
	
		self_article_status_changed(self_get(),arts, art_qty);
	}}
#line 1577 "queue.c"
#undef __GOB_FUNCTION__

#line 634 "pan/pan/queue.gob"
static void 
queue_remove_article_state (const Article ** arts, int art_qty, int state)
#line 1583 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::remove_article_state"
#line 634 "pan/pan/queue.gob"
	g_return_if_fail (arts != NULL);
#line 634 "pan/pan/queue.gob"
	g_return_if_fail (art_qty > 0);
#line 634 "pan/pan/queue.gob"
	g_return_if_fail (state != 0);
#line 1592 "queue.c"
{
#line 635 "pan/pan/queue.gob"
	
		int i;
		
		/* sanity clause */
		g_return_if_fail(IS_ARTICLE(arts[0]));
		
		/* remove the state */
		for (i=0; i<art_qty; ++i)
		{
			const Article * id = arts[i];
			const int new_state = self_get_article_status(id) & ~state;
			if (!new_state)
				g_hash_table_remove(article_hash, id);
			else
			{
				g_object_ref(id);
				g_hash_table_insert(article_hash,
									 id,
									 GINT_TO_POINTER(new_state));
			}
		}
		
		self_article_status_changed(self_get(),arts, art_qty);
	}}
#line 1619 "queue.c"
#undef __GOB_FUNCTION__

#line 660 "pan/pan/queue.gob"
static int 
queue_task_get_type_state (const Task * task)
#line 1625 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::task_get_type_state"
#line 660 "pan/pan/queue.gob"
	g_return_val_if_fail (task != NULL, (int )0);
#line 660 "pan/pan/queue.gob"
	g_return_val_if_fail (IS_TASK (task), (int )0);
#line 1632 "queue.c"
{
#line 661 "pan/pan/queue.gob"
	
		int state = 0;
		
		switch (task->type)
		{
			case TASK_TYPE_BODY:
			case TASK_TYPE_BODIES:
				state |= QUEUE_MESSAGE_ID_DOWNLOAD;
				break;
			case TASK_TYPE_SAVE:
				state |= QUEUE_MESSAGE_ID_SAVE;
				break;
			case TASK_TYPE_HEADERS:
				break;
			default:
				state = 0;
				break;
		}
	
		return state;
	}}
#line 1656 "queue.c"
#undef __GOB_FUNCTION__

#line 683 "pan/pan/queue.gob"
static void 
queue_add_articles_forall_func (Task * task, Article ** arts, int art_qty, gpointer state_gpointer)
#line 1662 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::add_articles_forall_func"
{
#line 687 "pan/pan/queue.gob"
	
		int i;
		const int state = GPOINTER_TO_INT(state_gpointer);
		/* const PString ** pstrs = g_newa(const PString*, mid_qty);
		for (i=0; i<mid_qty; ++i)
			pstrs[i] = &mids[i]->message_id; */
		self_add_article_state(arts, art_qty, state);
	}}
#line 1675 "queue.c"
#undef __GOB_FUNCTION__

#line 696 "pan/pan/queue.gob"
static void 
queue_add_articles (Task * task)
#line 1681 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::add_articles"
{
#line 697 "pan/pan/queue.gob"
	
		const int state = self_task_get_type_state(task);
		if (state)
			task_forall_articles(task,
									 self_add_articles_forall_func, 
									 GINT_TO_POINTER(state));
	}}
#line 1693 "queue.c"
#undef __GOB_FUNCTION__

#line 705 "pan/pan/queue.gob"
static void 
queue_remove_articles_forall_func (Task * task, Article ** arts, int art_qty, gpointer state_gpointer)
#line 1699 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::remove_articles_forall_func"
{
#line 709 "pan/pan/queue.gob"
	
		int i;
		const int state = GPOINTER_TO_INT(state_gpointer);
		/* const PString ** pstrs = g_newa(const PString*, mid_qty);
		for (i=0; i<mid_qty; ++i)
			pstrs[i] = &mids[i]->message_id; */
		self_remove_article_state(arts, art_qty, state);
	}}
#line 1712 "queue.c"
#undef __GOB_FUNCTION__

#line 718 "pan/pan/queue.gob"
static void 
queue_remove_articles (Task * task)
#line 1718 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::remove_articles"
{
#line 719 "pan/pan/queue.gob"
	
		const int state = self_task_get_type_state(task);
		if (state)
			task_forall_articles(task,
									 self_remove_articles_forall_func,
									 GINT_TO_POINTER(state));
	}}
#line 1730 "queue.c"
#undef __GOB_FUNCTION__

#line 727 "pan/pan/queue.gob"
static void 
queue_save_tasks_forall (Task ** tasks, int task_qty, gpointer filename_gpointer)
#line 1736 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::save_tasks_forall"
{
#line 730 "pan/pan/queue.gob"
	
		task_xml_write((const char*)filename_gpointer,
						(const Task**)tasks,
						task_qty);
	}}
#line 1746 "queue.c"
#undef __GOB_FUNCTION__

#line 736 "pan/pan/queue.gob"
static void 
queue_task_work (Task * task)
#line 1752 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::task_work"
{
#line 737 "pan/pan/queue.gob"
	
		debug_enter("queue_task_work");
		inc_task_work(task);
		(*task->state.work_func)(task);
		dec_task_work(task);
	
		self_wakeup();
		debug_exit("queue_task_work");
	}}
#line 1766 "queue.c"
#undef __GOB_FUNCTION__

#line 747 "pan/pan/queue.gob"
static void 
queue_task_checkin_channel (Task * task, GIOChannel * channel, gboolean channel_ok, gpointer user_data)
#line 1772 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::task_checkin_channel"
{
#line 751 "pan/pan/queue.gob"
	
		debug_enter("queue_task_checkin_channel");
		dec_task_work(task);
		socket_pool_checkin(channel, channel_ok);
		self_wakeup();
		debug_exit("queue_task_checkin_channel");
	}}
#line 1784 "queue.c"
#undef __GOB_FUNCTION__

#line 759 "pan/pan/queue.gob"
static void 
queue_task_give_socket (Task * task, GIOChannel * channel)
#line 1790 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::task_give_socket"
{
#line 761 "pan/pan/queue.gob"
	
		inc_task_work(task);
	
		task_give_socket(task,
						  channel,
						  queue_task_checkin_channel,
						  NULL);
	}}
#line 1803 "queue.c"
#undef __GOB_FUNCTION__

#line 770 "pan/pan/queue.gob"
static void 
queue_run_tasks_foreach (gpointer task_gpointer, gpointer user_data)
#line 1809 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::run_tasks_foreach"
{
#line 771 "pan/pan/queue.gob"
	
		Task * task = TASK(task_gpointer);
		GSList ** cull = (GSList**) user_data;
		TaskState state = task->state;
		QueueTaskStatus qts = self_get_task_status(task); 
		char desc[512];
debug_enter("queue_run_tasks_foreach");
		status_item_describe(STATUS_ITEM(task), desc, sizeof(desc));
		debug5(DEBUG_QUEUE,
			"tasks_foreach: task %p (%s) task-state %d task_work %d queue-state %d",
			task, desc, (int)state.health, (int)state.work, (int)qts);
	
		switch (state.health)
		{
			case TASK_FAIL:
			{
				if (qts != QUEUE_TASK_STATUS_STOPPED)
				{
					if (_remove_failed_tasks)
						*cull = g_slist_prepend(*cull, task);
					else
						self_set_task_status(
							  task, QUEUE_TASK_STATUS_STOPPED);
				}
				break;
			}
			case TASK_FAIL_NETWORK:
			{
				/* for now, just retry.
				   maybe at some point in the future
				   we can have the task sleep a bit first.
				   note the intentional fall-through. */
				task_state_set_health(&task->state, TASK_OK);
			}
			case TASK_OK:
			{
				const gboolean runnable =
					qts==QUEUE_TASK_STATUS_QUEUED ||
					qts==QUEUE_TASK_STATUS_RUNNING;
	
				switch (state.work)
				{
					case TASK_NEED_SOCKET:
						if (runnable)
						{
							GIOChannel * channel;
							SocketPool * pool = get_socket_pool_from_server(state.server);
							socket_pool_request_connection(pool);
							channel = socket_pool_checkout(pool);
							if (channel != NULL)
								self_task_give_socket(task, channel);
						}
						break;
	
					case TASK_NEED_WORK:
					case TASK_NEED_WORK_SUBTHREAD:
						if (runnable)
							self_task_work(task);
						break;
	
					case TASK_WORKING:
						/* no-op; the task is busy */
						break;
	
					case TASK_COMPLETED:
						*cull = g_slist_prepend(*cull, task);
						break;
	
					default:
						g_warning("unhandled state");
						break;
				}
			}
		}
debug_exit("queue_run_tasks_foreach");
	}}
#line 1890 "queue.c"
#undef __GOB_FUNCTION__

#line 848 "pan/pan/queue.gob"
static gboolean 
queue_upkeep (gpointer do_loop)
#line 1896 "queue.c"
{
#define __GOB_FUNCTION__ ":Queue::upkeep"
{
#line 849 "pan/pan/queue.gob"
	
		/* try to process the queue */
		GSList * cull = NULL;
		g_slist_foreach(task_list, self_run_tasks_foreach, &cull);
		if (cull != NULL)
		{
			self_remove_tasks(cull);
			g_slist_free(cull);
		}
	
		/* maybe backup the tasks */
		if (_dirty)
		{
			char * filename = self_get_tasks_filename();
			self_forall_tasks(self_save_tasks_forall, filename, TRUE);
			g_free(filename);
	
			_dirty = FALSE;
		}
	
		/* maybe invoke again in awhile */
		queue_quick_timer_id = 0u;
		return do_loop != NULL;
	}}
#line 1925 "queue.c"
#undef __GOB_FUNCTION__
