/* Generated by GOB (v2.0.12)   (do not edit directly) */



/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __QUEUE_H__
#define __QUEUE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <pan/base/article.h>
#include <pan/base/pstring.h>
#include <pan/task.h>

typedef void (QueueForallTaskFunc)(Task   ** tasks,
                                   int       task_qty,
                                   gpointer  user_data);



typedef enum {
	QUEUE_TASK_STATUS_NOT_QUEUED = 0,
	QUEUE_TASK_STATUS_QUEUED,
	QUEUE_TASK_STATUS_RUNNING,
	QUEUE_TASK_STATUS_STOPPING,
	QUEUE_TASK_STATUS_STOPPED,
	QUEUE_TASK_STATUS_REMOVING
} QueueTaskStatus;
#define QUEUE_TYPE_TASK_STATUS queue_task_status_get_type()
GType queue_task_status_get_type (void);


typedef enum {
	QUEUE_MESSAGE_ID_DOWNLOAD = 1,
	QUEUE_MESSAGE_ID_SAVE = 2
} QueueEnum;
#define QUEUE_TYPE_ENUM queue_enum_get_type()
GType queue_enum_get_type (void);


/*
 * Type checking and casting macros
 */
#define TYPE_QUEUE	(queue_get_type())
#define QUEUE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), queue_get_type(), Queue)
#define QUEUE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), queue_get_type(), Queue const)
#define QUEUE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), queue_get_type(), QueueClass)
#define IS_QUEUE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), queue_get_type ())

#define QUEUE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), queue_get_type(), QueueClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_QUEUE__
#define __TYPEDEF_QUEUE__
typedef struct _Queue Queue;
#endif
struct _Queue {
	GObject __parent__;
};

/*
 * Class definition
 */
typedef struct _QueueClass QueueClass;
struct _QueueClass {
	GObjectClass __parent__;
	/*signal*/void (* size_changed) (Queue * self, guint running_qty, guint total_qty);
	/*signal*/void (* connection_size_changed) (Queue * self, gint increment);
	/*signal*/void (* article_status_changed) (Queue * self, const Article ** articles, gint article_qty);
	/*signal*/void (* online_status_changed) (Queue * self, gboolean online);
	/*signal*/void (* tasks_added) (Queue * self, GSList * new_tasks, gint position_in_queue);
	/*signal*/void (* tasks_removed) (Queue * self, GSList * tasks);
	/*signal*/void (* tasks_moved) (Queue * self, GSList * tasks, gint new_start_index);
};


/*
 * Public methods
 */
GType	queue_get_type	(void);
void 	queue_startup	(gboolean online,
					gboolean remove_failed_tasks);
void 	queue_shutdown	(void);
Queue * 	queue_get	(void);
void 	queue_add	(Task * task);
void 	queue_set_online	(gboolean online);
gboolean 	queue_is_online	(void);
int 	queue_get_article_status	(const Article * article);
void 	queue_forall_tasks	(QueueForallTaskFunc forall_func,
					gpointer forall_func_user_data,
					gboolean run_even_if_no_tasks);
gboolean 	queue_is_empty	(void);
void 	queue_insert_tasks	(const GSList * tasks,
					gint index);
void 	queue_stop_tasks	(const GSList * tasks);
void 	queue_remove_tasks	(const GSList * tasks);
void 	queue_remove_last_task	(void);
void 	queue_move_tasks	(GSList * tasks,
					gint index);
void 	queue_requeue_failed_tasks	(const GSList * tasks);
gboolean 	queue_get_remove_failed_tasks	(void);
void 	queue_set_remove_failed_tasks	(gboolean b);
void 	queue_wakeup	(void);
QueueTaskStatus 	queue_get_task_status	(const Task * task);
char * 	queue_get_tasks_filename	(void);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define queue_connect__size_changed(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"size_changed",(GCallback) __extension__ ({void (* ___size_changed) (Queue * ___fake___self, guint ___fake___running_qty, guint ___fake___total_qty, gpointer ___data ) = (func); ___size_changed; }), (data))
#define queue_connect_after__size_changed(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"size_changed",(GCallback) __extension__ ({void (* ___size_changed) (Queue * ___fake___self, guint ___fake___running_qty, guint ___fake___total_qty, gpointer ___data ) = (func); ___size_changed; }), (data))
#define queue_connect_data__size_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"size_changed",(GCallback) __extension__ ({void (* ___size_changed) (Queue * ___fake___self, guint ___fake___running_qty, guint ___fake___total_qty, gpointer ___data ) = (func); ___size_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__connection_size_changed(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"connection_size_changed",(GCallback) __extension__ ({void (* ___connection_size_changed) (Queue * ___fake___self, gint ___fake___increment, gpointer ___data ) = (func); ___connection_size_changed; }), (data))
#define queue_connect_after__connection_size_changed(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"connection_size_changed",(GCallback) __extension__ ({void (* ___connection_size_changed) (Queue * ___fake___self, gint ___fake___increment, gpointer ___data ) = (func); ___connection_size_changed; }), (data))
#define queue_connect_data__connection_size_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"connection_size_changed",(GCallback) __extension__ ({void (* ___connection_size_changed) (Queue * ___fake___self, gint ___fake___increment, gpointer ___data ) = (func); ___connection_size_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__article_status_changed(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"article_status_changed",(GCallback) __extension__ ({void (* ___article_status_changed) (Queue * ___fake___self, const Article ** ___fake___articles, gint ___fake___article_qty, gpointer ___data ) = (func); ___article_status_changed; }), (data))
#define queue_connect_after__article_status_changed(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"article_status_changed",(GCallback) __extension__ ({void (* ___article_status_changed) (Queue * ___fake___self, const Article ** ___fake___articles, gint ___fake___article_qty, gpointer ___data ) = (func); ___article_status_changed; }), (data))
#define queue_connect_data__article_status_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"article_status_changed",(GCallback) __extension__ ({void (* ___article_status_changed) (Queue * ___fake___self, const Article ** ___fake___articles, gint ___fake___article_qty, gpointer ___data ) = (func); ___article_status_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__online_status_changed(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"online_status_changed",(GCallback) __extension__ ({void (* ___online_status_changed) (Queue * ___fake___self, gboolean ___fake___online, gpointer ___data ) = (func); ___online_status_changed; }), (data))
#define queue_connect_after__online_status_changed(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"online_status_changed",(GCallback) __extension__ ({void (* ___online_status_changed) (Queue * ___fake___self, gboolean ___fake___online, gpointer ___data ) = (func); ___online_status_changed; }), (data))
#define queue_connect_data__online_status_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"online_status_changed",(GCallback) __extension__ ({void (* ___online_status_changed) (Queue * ___fake___self, gboolean ___fake___online, gpointer ___data ) = (func); ___online_status_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__tasks_added(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_added",(GCallback) __extension__ ({void (* ___tasks_added) (Queue * ___fake___self, GSList * ___fake___new_tasks, gint ___fake___position_in_queue, gpointer ___data ) = (func); ___tasks_added; }), (data))
#define queue_connect_after__tasks_added(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_added",(GCallback) __extension__ ({void (* ___tasks_added) (Queue * ___fake___self, GSList * ___fake___new_tasks, gint ___fake___position_in_queue, gpointer ___data ) = (func); ___tasks_added; }), (data))
#define queue_connect_data__tasks_added(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_added",(GCallback) __extension__ ({void (* ___tasks_added) (Queue * ___fake___self, GSList * ___fake___new_tasks, gint ___fake___position_in_queue, gpointer ___data ) = (func); ___tasks_added; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__tasks_removed(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_removed",(GCallback) __extension__ ({void (* ___tasks_removed) (Queue * ___fake___self, GSList * ___fake___tasks, gpointer ___data ) = (func); ___tasks_removed; }), (data))
#define queue_connect_after__tasks_removed(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_removed",(GCallback) __extension__ ({void (* ___tasks_removed) (Queue * ___fake___self, GSList * ___fake___tasks, gpointer ___data ) = (func); ___tasks_removed; }), (data))
#define queue_connect_data__tasks_removed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_removed",(GCallback) __extension__ ({void (* ___tasks_removed) (Queue * ___fake___self, GSList * ___fake___tasks, gpointer ___data ) = (func); ___tasks_removed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define queue_connect__tasks_moved(object,func,data)	g_signal_connect(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_moved",(GCallback) __extension__ ({void (* ___tasks_moved) (Queue * ___fake___self, GSList * ___fake___tasks, gint ___fake___new_start_index, gpointer ___data ) = (func); ___tasks_moved; }), (data))
#define queue_connect_after__tasks_moved(object,func,data)	g_signal_connect_after(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_moved",(GCallback) __extension__ ({void (* ___tasks_moved) (Queue * ___fake___self, GSList * ___fake___tasks, gint ___fake___new_start_index, gpointer ___data ) = (func); ___tasks_moved; }), (data))
#define queue_connect_data__tasks_moved(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(__extension__ ({Queue *___object = (object); ___object; })),"tasks_moved",(GCallback) __extension__ ({void (* ___tasks_moved) (Queue * ___fake___self, GSList * ___fake___tasks, gint ___fake___new_start_index, gpointer ___data ) = (func); ___tasks_moved; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define queue_connect__size_changed(object,func,data)	g_signal_connect(QUEUE(object),"size_changed",(GCallback)(func),(data))
#define queue_connect_after__size_changed(object,func,data)	g_signal_connect_after(QUEUE(object),"size_changed",(GCallback)(func),(data))
#define queue_connect_data__size_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"size_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__connection_size_changed(object,func,data)	g_signal_connect(QUEUE(object),"connection_size_changed",(GCallback)(func),(data))
#define queue_connect_after__connection_size_changed(object,func,data)	g_signal_connect_after(QUEUE(object),"connection_size_changed",(GCallback)(func),(data))
#define queue_connect_data__connection_size_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"connection_size_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__article_status_changed(object,func,data)	g_signal_connect(QUEUE(object),"article_status_changed",(GCallback)(func),(data))
#define queue_connect_after__article_status_changed(object,func,data)	g_signal_connect_after(QUEUE(object),"article_status_changed",(GCallback)(func),(data))
#define queue_connect_data__article_status_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"article_status_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__online_status_changed(object,func,data)	g_signal_connect(QUEUE(object),"online_status_changed",(GCallback)(func),(data))
#define queue_connect_after__online_status_changed(object,func,data)	g_signal_connect_after(QUEUE(object),"online_status_changed",(GCallback)(func),(data))
#define queue_connect_data__online_status_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"online_status_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__tasks_added(object,func,data)	g_signal_connect(QUEUE(object),"tasks_added",(GCallback)(func),(data))
#define queue_connect_after__tasks_added(object,func,data)	g_signal_connect_after(QUEUE(object),"tasks_added",(GCallback)(func),(data))
#define queue_connect_data__tasks_added(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"tasks_added",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__tasks_removed(object,func,data)	g_signal_connect(QUEUE(object),"tasks_removed",(GCallback)(func),(data))
#define queue_connect_after__tasks_removed(object,func,data)	g_signal_connect_after(QUEUE(object),"tasks_removed",(GCallback)(func),(data))
#define queue_connect_data__tasks_removed(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"tasks_removed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define queue_connect__tasks_moved(object,func,data)	g_signal_connect(QUEUE(object),"tasks_moved",(GCallback)(func),(data))
#define queue_connect_after__tasks_moved(object,func,data)	g_signal_connect_after(QUEUE(object),"tasks_moved",(GCallback)(func),(data))
#define queue_connect_data__tasks_moved(object,func,data,destroy_data,flags)	g_signal_connect_data(QUEUE(object),"tasks_moved",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
