/* Generated by GOB (v2.0.12) on Fri Oct 07 00:43:21 2005
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */


#line 2 "pan/pan/task-headers.gob"

/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#line 29 "task-headers.c"
#define GOB_VERSION_MAJOR 2
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 12

#define selfp (self->_priv)

#include <string.h> /* memset() */

#include "task-headers.h"

#ifdef G_LIKELY
#define ___GOB_LIKELY(expr) G_LIKELY(expr)
#define ___GOB_UNLIKELY(expr) G_UNLIKELY(expr)
#else /* ! G_LIKELY */
#define ___GOB_LIKELY(expr) (expr)
#define ___GOB_UNLIKELY(expr) (expr)
#endif /* G_LIKELY */

#line 29 "pan/pan/task-headers.gob"

#include <config.h>

#include <glib.h>
#include <glib/gi18n-lib.h>

#include <pan/base/article.h>
#include <pan/base/article-thread.h>
#include <pan/base/debug.h>
#include <pan/base/log.h>
#include <pan/base/pan-glib-extensions.h>
#include <pan/base/db-add.h>
#include <pan/base/group.h>
#include <pan/base/server.h>

#include <pan/nntp.h>
#include <pan/queue.h>
#include <pan/task-bodies.h>
#include <pan/rules/rule-manager.h>

#define SAMPLE_SIZE_DEFAULT 150
#define DEAD_POINTER ((void*)(0xDEADBEEF))

/* #ifndef __TYPEDEF_TASK_HEADERS__
#define __TYPEDEF_TASK_HEADERS__
typedef struct _TaskHeaders TaskHeaders;
#endif
 */
static void mark_all_articles_old(Group *group, Article **articles, guint qty, gpointer data)
{
	if(qty>0u)
		articles_set_old(articles,qty);
}

static void mark_read_articles_old(Group *group, Article **articles, guint qty, gpointer data)
{
	guint i;
	GPtrArray * read;

	/* get a list of read articles */
	read = g_ptr_array_sized_new(qty);
	for (i=0; i!=qty; ++i)
		if (article_is_read(articles[i]))
			g_ptr_array_add(read, articles[i]);

	/* mark those articles as old */
	if (read->len > 0)
		articles_set_old((Article**)read->pdata, read->len);

	/* cleanup */
	g_ptr_array_free(read, TRUE);
}

typedef struct
{
	Task * task;
	TaskHeaders * task_h;
	StatusItem * status;

	Group * group;

	const char * charset;

	gulong high_number_so_far;
	gulong fetch_hi;
	gulong fetch_lo;
	gulong group_lo;
	gulong group_hi;
	gulong group_qty;

	HeaderDownloadType download_type;
	gulong sample_size;

	gulong articles_added;

	GPtrArray * new_articles;
}
TaskHeadersWorkData;

static const TaskHeadersWorkData DEAD_WORK_DATA = 
{
	DEAD_POINTER, DEAD_POINTER, DEAD_POINTER,
	DEAD_POINTER,
	DEAD_POINTER,
	~0, ~0, ~0, ~0, ~0, ~0,
	~0, ~0,
	~0,
	DEAD_POINTER
};

static void
xover_line_func(GIOChannel      * channel,
                 const char      * line,
                 int               line_len,
                 gpointer          user_data)
{
	TaskHeadersWorkData * wdata = (TaskHeadersWorkData*) user_data;

	const char * pch;
	const char * s;
	const char * march = line;
	const PString group_name = *group_get_name(wdata->group);
	char norm_buf[4096];
	int norm_len = 0;
	PString norm = PSTRING_INIT;
	time_t date_val;

	gulong number, byte_qty, line_qty;
	PString subject = PSTRING_INIT;
	PString author = PSTRING_INIT;
	PString date = PSTRING_INIT;
	PString message_id = PSTRING_INIT;
	PString references = PSTRING_INIT;
	PString xref = PSTRING_INIT;
	PString tok = PSTRING_INIT;

	/***
	****  Tokenize the line
	***/

	number = get_next_token_ulong(march, '\t', &march);
	get_next_token_pstring(march, '\t', &march, &tok); subject = pstring_strstrip_shallow(&tok);
	if(!pstring_is_set(&subject))
		subject=pstring_shallow("(no subject)",-1);
	get_next_token_pstring(march, '\t', &march, &tok); author = pstring_strstrip_shallow(&tok);
	get_next_token_pstring(march, '\t', &march, &tok); date = pstring_strstrip_shallow(&tok);
	get_next_token_pstring(march, '\t', &march, &tok); message_id = pstring_strstrip_shallow(&tok);
	get_next_token_pstring(march, '\t', &march, &tok); references = pstring_strstrip_shallow(&tok);
	byte_qty = get_next_token_ulong(march, '\t', &march);
	line_qty = get_next_token_ulong(march, '\t', &march);
	get_next_token_pstring(march, '\t', &march, &tok); xref = pstring_strstrip_shallow(&tok);
	//if (xref.len>6 && !strncmp(xref.str,"Xref: ", 6)) {
	//	xref = pstring_substr_shallow(&xref, xref.str+6, NULL); /* skip "Xref: " */
	//	xref = pstring_strstrip_shallow(&xref); /* remove trailing linefeed */
	//}

	/* does it look valid? */
	if (!number
		|| !pstring_is_set(&subject) /* missing subject */
		|| !pstring_is_set(&author) /* missing author */
		|| !pstring_is_set(&date) /* missing date */
		|| !pstring_is_set(&message_id) /* missing mid */
		|| message_id.str[0]!='<' /* corrupt mid */
		|| !(!pstring_is_set(&references) || references.str[0]=='<') /* corrupt references */
		)
	{
		GString * gstr = g_string_new(_("Corrupt header skipped: "));
		g_string_append_len(gstr, line, line_len);
		log_add(LOG_INFO, gstr->str);
		g_string_free(gstr, TRUE);
		return;
	}

	wdata->high_number_so_far = MAX(wdata->high_number_so_far, number);

	date_val = g_mime_utils_header_decode_date(date.str, NULL);

	if (1)
	{
		article_add_s * a;
		++wdata->articles_added;

		/* create the new article */
		a = g_new0(article_add_s,1);
		a->uid = number;
		a->subject = pstring_shallow(pan_header_to_utf8(subject.str, subject.len, wdata->charset), -1);
		a->author=pstring_shallow(pan_header_to_utf8(author.str, author.len, wdata->charset), -1);;
		a->date = date_val;
		a->msg_id=pstring_shallow(g_mime_utils_decode_message_id(message_id.str),-1);
		a->byte_qty = byte_qty;
		a->lines = line_qty;
		if (pstring_is_set(&references)) pstring_copy(&a->refs, &references);
		if (pstring_is_set(&xref)) pstring_copy(&a->xref, &xref);
		
		/* Add the article to the article list */
		g_ptr_array_add(wdata->new_articles, a);
	}

	/* update the count & progress ui */
	{
		const gulong tot = wdata->articles_added;
		status_item_emit_next_step(wdata->status);
		if (!(tot % 100ul)) 
		{
			if (!tot)
				status_item_emit_status(wdata->status, _("Fetching articles"));
			else 
				status_item_emit_status_va(wdata->status, _("%lu Articles"), wdata->articles_added);
		}
	}
}

static void
wdata_free(TaskHeadersWorkData * wdata)
{
	g_return_if_fail(wdata != NULL);
	guint i;
	GPtrArray *arts=wdata->new_articles;
	
	for(i=0;i<arts->len;++i)
	{
		article_add_s *a=g_ptr_array_index(arts,i);
		pstring_clear(&a->subject);
		pstring_clear(&a->author);
		pstring_clear(&a->msg_id);
		pstring_clear(&a->refs);
		pstring_clear(&a->xref);
		g_free(a);
	}
	g_ptr_array_free(wdata->new_articles, TRUE);

	*wdata = DEAD_WORK_DATA;
	g_free(wdata);
}

static void task_headers_run_download(Task * task, GIOChannel * channel);

static void
xover_done_func(GIOChannel       * channel,
                 TaskStateEnum      state,
                 gpointer           user_data)
{
	TaskHeadersWorkData * wdata = (TaskHeadersWorkData*) user_data;
	TaskHeaders * task_h = wdata->task_h;
	GPtrArray * new_articles = wdata->new_articles;
	StatusItem * status = wdata->status;

	if (state == TASK_OK)
		status_item_emit_progress(wdata->status, 100);

	/* let the user know what we got */
	log_add_va(LOG_INFO, _("Added %lu articles in \"%s\""),
		wdata->articles_added,
		group_get_name(task_h->group)->str);

	/* update the articles' "new" state:
	   if we haven't read the group since the last time we fetched headers, mark nothing as old.
	   otherwise if there were new articles, mark all the previous ones as old.
	   otherwise mark all the previous read ones as old. */
	if (group_loaded_since_fetch(task_h->group))
	{
		group_set_loaded_since_fetch(task_h->group,FALSE);

		//if (changed->len)
		//	group_article_forall(task_h->group, mark_all_articles_old, NULL);
		GPtrArray *articles=NULL;
		if(articles=group_get_all_articles(task_h->group,NULL))
		{
			if(articles->len>0)
			{
				articles_set_old((Article**)articles->pdata, articles->len);
				g_ptr_array_foreach(articles,pan_g_ptr_array_unref,NULL);
			}
			g_ptr_array_free(articles,TRUE);
		}
		//else
		//	group_article_forall(task_h->group, mark_read_articles_old, NULL);
	}
	
	{
		const int max_len=200;
		GArray *ids;
		GPtrArray *arts=g_ptr_array_sized_new(max_len);
		guint i;
		GTimer *timer=g_timer_new();
		
		g_timer_start(timer);
		while(new_articles->len >0)
		{
			i=MIN(max_len,new_articles->len);
			
			/* give the group the new articles */
			ids=add_articles(task_h->group->id, task_get_server(wdata->task)->id, (const article_add_s**)(new_articles->pdata), i, status);
			g_ptr_array_remove_range(new_articles,0,i);
			
			// putting at end means extra execution
			//g_ptr_array_remove_range(arts,0,arts->len);
			arts->len=0;
			for(i=0;i<ids->len;++i)
				g_ptr_array_add(arts,article_new(g_array_index(ids,gint64,i)));
			g_array_free(ids,TRUE);
			
			// don't stall main loop
			if(g_timer_elapsed(timer,NULL)>0.25)
			{
				while(g_main_context_pending(NULL))
					g_main_context_iteration(NULL,FALSE);
				g_timer_reset(timer);
			}
			
			/* apply the rules to the changed articles */
			rule_manager_process_incoming_articles(arts,task_h->group);
			
			// don't stall main loop
			if(g_timer_elapsed(timer,NULL)>0.25)
			{
				while(g_main_context_pending(NULL))
					g_main_context_iteration(NULL,FALSE);
				g_timer_reset(timer);
			}
			
			/* do we need to download these? */
			if (new_articles->len && task_h->download_bodies)
			{
				Article ** a = (Article **) arts->pdata;
				queue_add(TASK(task_bodies_new(a,  arts->len)));
			}
			g_ptr_array_foreach(arts,pan_g_ptr_array_unref,NULL);
		}
		g_ptr_array_free(arts,TRUE);
		g_timer_destroy(timer);
	}
	
	/* refresh task state.
	   this destroys the task if !channel_ok,
	   so don't reference 'task' or 'status' past this point */
	task_state_set_health(&wdata->task->state, state);
	if (state == TASK_OK)
	{
		task_state_set_work_completed(&wdata->task->state);
		if(task_next_server(wdata->task))
			task_state_set_work_need_socket(&wdata->task->state,
		                                 task_get_server(wdata->task),
		                                 task_headers_run_download);
		else // no next server so update group
		{
			group_update_counts(wdata->task_h->group);
			thread_group(task_h->group->id);
			group_headers_retrieved(task_h->group);
		}
	}
	else
	{
		log_add_va(LOG_INFO,"task-headers: state %d not OK. redoing xover.",state);
		task_state_set_work_need_socket(&wdata->task->state,
		                                 task_get_server(wdata->task),
		                                 task_headers_run_download);
	}
	// should this line be moved up?
	task_checkin_socket(wdata->task, channel, state==TASK_OK);
	/* cleanup */
	wdata_free(wdata);
}

static void
group_cmd_data_func(GIOChannel * io,
                     gulong qty,
                     gulong lo,
                     gulong hi,
                     GQuark group_quark,
                     gpointer user_data)
{
	TaskHeadersWorkData * wdata = ( TaskHeadersWorkData *) user_data;

	wdata->group_lo = lo;
	wdata->group_hi = hi;
	wdata->group_qty = qty;

	switch (wdata->download_type)
	{
		case HEADERS_NEW:
		{
			const gulong p_last = group_get_article_high(wdata->group, task_get_server(wdata->task));
			wdata->fetch_lo = MAX(lo, p_last+1);
			wdata->fetch_hi = hi;
			break;	
		}

		case HEADERS_SAMPLE:
			wdata->fetch_lo = hi - MIN(qty, wdata->sample_size);
			wdata->fetch_hi = hi;
			break;

		case HEADERS_ALL:
			wdata->fetch_lo = lo;
			wdata->fetch_hi = hi;
			break;

		default:
			pan_warn_if_reached();
			wdata->fetch_lo = 0ul;
			wdata->fetch_hi = 0ul;
			break;
	}
}

static void
group_cmd_done_func(GIOChannel       * channel,
                     TaskStateEnum      state,
                     gpointer           user_data)
{
	TaskHeadersWorkData * wdata = ( TaskHeadersWorkData *) user_data;

	if (state != TASK_OK)
	{
		/* set state */
		task_state_set_health(&wdata->task->state, state);
		task_state_set_work_need_socket(&wdata->task->state, task_get_server(wdata->task), task_headers_run_download);
		task_checkin_socket(wdata->task, channel, FALSE);
		log_add_va(LOG_INFO,"group_cmd_done: state %d not OK. redoing.",state);
		
		wdata_free(wdata);
	}
	else if (!wdata->group_qty || wdata->fetch_lo > wdata->fetch_hi)
	{
		/* no articles, or no new articles... */
		task_state_set_health(&wdata->task->state, TASK_OK);
		task_state_set_work_completed(&wdata->task->state);
		task_checkin_socket(wdata->task, channel, TRUE);
		if(task_next_server(wdata->task))
			task_state_set_work_need_socket(&wdata->task->state,
		                                 task_get_server(wdata->task),
		                                 task_headers_run_download);
		wdata_free(wdata);
	}
	else /* we have a valid range, so now we XOVER */
	{
		int steps;

		/* load the existing headers */
		//group_ref_articles(wdata->group, wdata->status);
		group_expire_articles_not_in_range(wdata->group, task_get_server(wdata->task), wdata->group_lo, wdata->group_hi); 
		//group_article_forall(wdata->group, build_multipart_lookup, wdata->all_articles_norm);
		//group_article_forall(wdata->group, build_mid_lookup, wdata->all_articles_mid);

		/* init the status item for the header download */
		steps = MAX(0, wdata->fetch_hi - wdata->fetch_lo);
		status_item_emit_init_steps(wdata->status, steps);

		/* get the article headers... */
		pan_g_ptr_array_reserve(wdata->new_articles, wdata->fetch_hi - wdata->fetch_lo);

		nntp_xover(channel,
		            &wdata->task->abort_flag,
		            xover_line_func, wdata,
		            xover_done_func, wdata,
		            wdata->fetch_lo, wdata->fetch_hi);
	}
}


#line 490 "task-headers.c"
static const GEnumValue _header_download_type_values[] = {
	{ HEADERS_ALL, (char *)"HEADERS_ALL", (char *)"all" },
	{ HEADERS_NEW, (char *)"HEADERS_NEW", (char *)"new" },
	{ HEADERS_SAMPLE, (char *)"HEADERS_SAMPLE", (char *)"sample" },
	{ 0, NULL, NULL }
};

GType
header_download_type_get_type (void)
{
	static GType type = 0;
	if ___GOB_UNLIKELY(type == 0)
		type = g_enum_register_static ("HeaderDownloadType", _header_download_type_values);
	return type;
}

/* self casting macros */
#define SELF(x) TASK_HEADERS(x)
#define SELF_CONST(x) TASK_HEADERS_CONST(x)
#define IS_SELF(x) IS_TASK_HEADERS(x)
#define TYPE_SELF TYPE_TASK_HEADERS
#define SELF_CLASS(x) TASK_HEADERS_CLASS(x)

#define SELF_GET_CLASS(x) TASK_HEADERS_GET_CLASS(x)

/* self typedefs */
typedef TaskHeaders Self;
typedef TaskHeadersClass SelfClass;

/* here are local prototypes */
static void task_headers_init (TaskHeaders * o) G_GNUC_UNUSED;
static void task_headers_class_init (TaskHeadersClass * c) G_GNUC_UNUSED;
static void task_headers_describe (const StatusItem * item, char * buf, int buflen) G_GNUC_UNUSED;
static TaskHeaders * task_headers_real_new (Group * group, HeaderDownloadType dl_type, gboolean bodies, int samp_size) G_GNUC_UNUSED;
static void task_headers_run_download (Task * task, GIOChannel * channel) G_GNUC_UNUSED;

/* pointer to the class of our parent */
static TaskClass *parent_class = NULL;

/* Short form macros */
#define self_describe task_headers_describe
#define self_real_new task_headers_real_new
#define self_new task_headers_new
#define self_new_with_bodies task_headers_new_with_bodies
#define self_new_sample task_headers_new_sample
#define self_run_download task_headers_run_download
GType
task_headers_get_type (void)
{
	static GType type = 0;

	if ___GOB_UNLIKELY(type == 0) {
		static const GTypeInfo info = {
			sizeof (TaskHeadersClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) task_headers_class_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			sizeof (TaskHeaders),
			10 /* n_preallocs */,
			(GInstanceInitFunc) task_headers_init,
			NULL
		};

		type = g_type_register_static (TYPE_TASK, "TaskHeaders", &info, (GTypeFlags)0);
	}

	return type;
}

/* a macro for creating a new object of our type */
#define GET_NEW ((TaskHeaders *)g_object_new(task_headers_get_type(), NULL))

/* a function for creating a new object of our type */
#include <stdarg.h>
static TaskHeaders * GET_NEW_VARG (const char *first, ...) G_GNUC_UNUSED;
static TaskHeaders *
GET_NEW_VARG (const char *first, ...)
{
	TaskHeaders *ret;
	va_list ap;
	va_start (ap, first);
	ret = (TaskHeaders *)g_object_new_valist (task_headers_get_type (), first, ap);
	va_end (ap);
	return ret;
}


static void
___dispose (GObject *obj_self)
{
#define __GOB_FUNCTION__ ":Task:Headers::dispose"
	TaskHeaders *self G_GNUC_UNUSED = TASK_HEADERS (obj_self);
	if (G_OBJECT_CLASS (parent_class)->dispose) \
		(* G_OBJECT_CLASS (parent_class)->dispose) (obj_self);
#line 481 "pan/pan/task-headers.gob"
	if(self->group) { g_object_unref ((gpointer) self->group); self->group = NULL; }
#line 589 "task-headers.c"
}
#undef __GOB_FUNCTION__

static void 
task_headers_init (TaskHeaders * o G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Task:Headers::init"
#line 29 "pan/pan/task-headers.gob"
	o->group = NULL;
#line 599 "task-headers.c"
}
#undef __GOB_FUNCTION__
static void 
task_headers_class_init (TaskHeadersClass * c G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Task:Headers::class_init"
	GObjectClass *g_object_class G_GNUC_UNUSED = (GObjectClass*) c;

	parent_class = g_type_class_ref (TYPE_TASK);

	g_object_class->dispose = ___dispose;
}
#undef __GOB_FUNCTION__



#line 487 "pan/pan/task-headers.gob"
static void 
task_headers_describe (const StatusItem * item, char * buf, int buflen)
#line 619 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::describe"
{
#line 488 "pan/pan/task-headers.gob"
	
		const char * name = item==NULL ? "" : group_get_name(SELF(item)->group)->str;
		const int type = item==NULL ? 0 : SELF(item)->download_type;
	
		if (type == HEADERS_ALL)
			g_snprintf(buf, buflen, _("Getting all headers for \"%s\""), name);
		else if (type == HEADERS_NEW)
			g_snprintf(buf, buflen, _("Getting new headers for \"%s\""), name);
		else
			g_snprintf(buf, buflen, _("Sampling headers for \"%s\""), name);
	}}
#line 635 "task-headers.c"
#undef __GOB_FUNCTION__

#line 500 "pan/pan/task-headers.gob"
static TaskHeaders * 
task_headers_real_new (Group * group, HeaderDownloadType dl_type, gboolean bodies, int samp_size)
#line 641 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::real_new"
{
#line 501 "pan/pan/task-headers.gob"
	
		Self *self=GET_NEW;
		Task *task=TASK(self);
		debug_enter("task_headers_real_new");
		
		g_object_ref(group);
		self->group=group;
		
		task_constructor(task,TASK_TYPE_HEADERS,self_describe,group_get_servers(group),TRUE);
		task_state_set_work_need_socket(&task->state,task_get_server(task),self_run_download);
		self->download_type=dl_type;
		self->download_bodies=bodies;
		self->body_index=0;
		self->sample_size=samp_size;
		debug_exit("task_headers_real_new");
		return self;
	}}
#line 663 "task-headers.c"
#undef __GOB_FUNCTION__

#line 519 "pan/pan/task-headers.gob"
TaskHeaders * 
task_headers_new (Group * group, HeaderDownloadType dl_type)
#line 669 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::new"
#line 519 "pan/pan/task-headers.gob"
	g_return_val_if_fail (group != NULL, (TaskHeaders * )0);
#line 519 "pan/pan/task-headers.gob"
	g_return_val_if_fail (IS_GROUP (group), (TaskHeaders * )0);
#line 676 "task-headers.c"
{
#line 520 "pan/pan/task-headers.gob"
	
		g_return_if_fail(!group_is_folder(group));
		return self_real_new(group,dl_type,FALSE,SAMPLE_SIZE_DEFAULT);
	}}
#line 683 "task-headers.c"
#undef __GOB_FUNCTION__

#line 525 "pan/pan/task-headers.gob"
TaskHeaders * 
task_headers_new_with_bodies (Group * group, HeaderDownloadType dl_type)
#line 689 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::new_with_bodies"
#line 525 "pan/pan/task-headers.gob"
	g_return_val_if_fail (group != NULL, (TaskHeaders * )0);
#line 525 "pan/pan/task-headers.gob"
	g_return_val_if_fail (IS_GROUP (group), (TaskHeaders * )0);
#line 696 "task-headers.c"
{
#line 526 "pan/pan/task-headers.gob"
	
		g_return_if_fail(!group_is_folder(group));
		return self_real_new(group,dl_type,TRUE,SAMPLE_SIZE_DEFAULT);
	}}
#line 703 "task-headers.c"
#undef __GOB_FUNCTION__

#line 531 "pan/pan/task-headers.gob"
TaskHeaders * 
task_headers_new_sample (Group * group, guint sample_size, gboolean download_bodies)
#line 709 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::new_sample"
#line 531 "pan/pan/task-headers.gob"
	g_return_val_if_fail (group != NULL, (TaskHeaders * )0);
#line 531 "pan/pan/task-headers.gob"
	g_return_val_if_fail (IS_GROUP (group), (TaskHeaders * )0);
#line 716 "task-headers.c"
{
#line 532 "pan/pan/task-headers.gob"
	
		g_return_if_fail(!group_is_folder(group));
		return self_real_new(group,HEADERS_SAMPLE,download_bodies,sample_size);
	}}
#line 723 "task-headers.c"
#undef __GOB_FUNCTION__

#line 537 "pan/pan/task-headers.gob"
static void 
task_headers_run_download (Task * task, GIOChannel * channel)
#line 729 "task-headers.c"
{
#define __GOB_FUNCTION__ ":Task:Headers::run_download"
{
#line 538 "pan/pan/task-headers.gob"
	
	
		TaskHeaders * task_h = SELF(task);
		TaskHeadersWorkData * wdata;
		debug_enter("task_headers_run_download");
	
		/* set current state */
		task_state_set_work_working(&task->state);
	
		/* prep this mammoth state struct so that we can pass it around
		   during the GROUP and XOVER commands that follow */
		wdata = g_new(TaskHeadersWorkData, 1);
		wdata->task = task;
		wdata->task_h = task_h;
		wdata->status = STATUS_ITEM(task);
		wdata->group = task_h->group;
		wdata->charset = group_get_default_charset(wdata->group);
		wdata->high_number_so_far = 0ul;
		wdata->fetch_hi = 0ul;
		wdata->fetch_lo = 0ul;
		wdata->group_lo = 0ul;
		wdata->group_hi = 0ul;
		wdata->group_qty = 0ul;
		wdata->download_type = task_h->download_type;
		wdata->sample_size = task_h->sample_size;
		wdata->new_articles = g_ptr_array_new();
		//wdata->parts_added = 0;
		wdata->articles_added = 0;
		//wdata->changed_articles = g_hash_table_new(g_direct_hash, g_direct_equal);
		//wdata->all_articles_mid = g_hash_table_new(pstring_hash, pstring_equal);
		//wdata->all_articles_norm = g_hash_table_new_full(pstring_hash,
		//												  pstring_equal,
		//												  (GDestroyNotify)pstring_free,
		//												  NULL);
	
	
		/* before we can XOVER, we need to set the GROUP so that we can
		   get up-to-date article numbers to build the XOVER command */
		nntp_group(channel,
					task_h->group->quark,
					group_cmd_data_func, wdata,
					group_cmd_done_func, wdata);
	
		debug_exit("task_headers_run_download");
	
	}}
#line 780 "task-headers.c"
#undef __GOB_FUNCTION__
