/* Generated by GOB (v2.0.12) on Fri Oct 07 00:43:21 2005
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */


#line 2 "pan/pan/task-post.gob"

/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#line 29 "task-post.c"
#define GOB_VERSION_MAJOR 2
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 12

#define selfp (self->_priv)

#include <string.h> /* memset() */

#include "task-post.h"

#ifdef G_LIKELY
#define ___GOB_LIKELY(expr) G_LIKELY(expr)
#define ___GOB_UNLIKELY(expr) G_UNLIKELY(expr)
#else /* ! G_LIKELY */
#define ___GOB_LIKELY(expr) (expr)
#define ___GOB_UNLIKELY(expr) (expr)
#endif /* G_LIKELY */

#line 30 "pan/pan/task-post.gob"

#include <config.h>

#include <glib.h>
#include <glib/gi18n-lib.h>

#include <pan/base/acache.h>
#include <pan/base/article.h>
#include <pan/base/debug.h>
#include <pan/base/gnksa.h>
#include <pan/base/log.h>
#include <pan/base/message-check.h>
#include <pan/base/pan-glib-extensions.h>
#include <pan/base/util-mime.h>
#include <pan/base/vserver.h>
#include <pan/base/serverlist.h>

#include <pan/globals.h>
#include <pan/message-check-ui.h>
#include <pan/nntp.h>
#include <pan/queue.h>
#include <pan/smtp.h>

enum MessageSendResult
{
	SMTP_FAILED     = (1<<0),
	NNTP_FAILED     = (1<<1)
};

/**
 * Populate a hashtable of internal headers in a message
 */
static void
build_nntp_message_foreach_header(const char * name, const char * value, gpointer user_data)
{
	if (article_header_is_internal(name))
		g_ptr_array_add(((GPtrArray*)(user_data)), (gpointer)name);
}

#if 0
static gssize
write_header_nofold(GMimeStream *stream, const char *name, const char *value)
{
	gssize nwritten;
	char * val;

	val = g_strdup_printf("%s: %s\n", name, value);
	nwritten = g_mime_stream_write_string(stream, val);
	g_free(val);

	return nwritten;
}
#endif

/**
 * Build the message that will be passed to the news server.
 * Error-checking is done elsewhere; by the time we reach this
 * point we assume it's in the clear and only work on building
 * the message.
 */
char*
build_nntp_message(GMimeMessage * message)
{
	char * tmp;
	GMimeMessage * clone;
	debug_enter("build_nntp_message");

	/* sanity checks... */
	g_return_val_if_fail(GMIME_IS_MESSAGE(message), NULL);

	/* clone the message so that we can fuck with it
	 * without harming the original. */
	if (1)
	{
		char * str;
		GMimeStream * stream;
		GMimeParser * parser;

		/*g_mime_header_set_default_write_func (GMIME_OBJECT(message)->headers,
		  write_header_nofold);*/

		str = g_mime_message_to_string(message);
		message = NULL;

		parser = g_mime_parser_new();
		stream = g_mime_stream_mem_new_with_buffer(str, strlen(str));
		g_mime_parser_init_with_stream(parser, stream);
                clone = g_mime_parser_construct_message(parser);

		g_object_unref(parser);
		g_object_unref(stream);
		g_free(str);
	}

	/* update the message's date -- it may have been in sendlater for awhile */
	if (1)
	{
		time_t now = time(0);
		const int offset_secs = tzoffset_sec(&now);
		g_mime_message_set_date(clone, now, (offset_secs/3600)*100);
	}

	/* maybe remove the message-id */
	if (g_mime_message_get_header(clone, PAN_NO_MESSAGE_ID) != NULL)
		g_mime_object_remove_header(GMIME_OBJECT(clone), HEADER_MESSAGE_ID);

	/* turn off folding. */
	/*g_mime_header_set_default_write_func (GMIME_OBJECT(clone)->headers,
	  write_header_nofold);*/


	/* remove the internal headers */
	if (1)
	{
		guint i;
		GPtrArray * a = g_ptr_array_new();
		GMimeHeader * h = GMIME_OBJECT(clone)->headers;
		g_mime_header_foreach(h, build_nntp_message_foreach_header, a);
		for (i=0; i<a->len; ++i)
			g_mime_header_remove(h, (const char*)g_ptr_array_index(a,i));
		g_ptr_array_free(a, TRUE);
	}

	/* make sure each line ends in \r\n */
	tmp = g_mime_message_to_string(clone);
	replace_gstr(&tmp, pan_substitute(tmp, "\n.", "\n.."));
	replace_gstr(&tmp, pan_substitute(tmp, "\n", "\r\n"));
	replace_gstr(&tmp, pan_substitute(tmp, "\r\r\n.", "\r\n"));

	/* cleanup */
	g_object_unref(clone);
	debug_exit("build_nntp_message");
	return tmp;
}


#line 185 "task-post.c"
/* self casting macros */
#define SELF(x) TASK_POST(x)
#define SELF_CONST(x) TASK_POST_CONST(x)
#define IS_SELF(x) IS_TASK_POST(x)
#define TYPE_SELF TYPE_TASK_POST
#define SELF_CLASS(x) TASK_POST_CLASS(x)

#define SELF_GET_CLASS(x) TASK_POST_GET_CLASS(x)

/* self typedefs */
typedef TaskPost Self;
typedef TaskPostClass SelfClass;

/* here are local prototypes */
static void task_post_init (TaskPost * o) G_GNUC_UNUSED;
static void task_post_class_init (TaskPostClass * c) G_GNUC_UNUSED;
static void task_post_describe (const StatusItem * status, char * buf, int len) G_GNUC_UNUSED;
static void task_post_ran (GIOChannel * channel, TaskStateEnum val, gpointer user_data) G_GNUC_UNUSED;
static void task_post_run (Task * task, GIOChannel * channel) G_GNUC_UNUSED;

/* pointer to the class of our parent */
static TaskClass *parent_class = NULL;

/* Short form macros */
#define self_describe task_post_describe
#define self_ran task_post_ran
#define self_run task_post_run
#define self_new task_post_new
GType
task_post_get_type (void)
{
	static GType type = 0;

	if ___GOB_UNLIKELY(type == 0) {
		static const GTypeInfo info = {
			sizeof (TaskPostClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) task_post_class_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			sizeof (TaskPost),
			10 /* n_preallocs */,
			(GInstanceInitFunc) task_post_init,
			NULL
		};

		type = g_type_register_static (TYPE_TASK, "TaskPost", &info, (GTypeFlags)0);
	}

	return type;
}

/* a macro for creating a new object of our type */
#define GET_NEW ((TaskPost *)g_object_new(task_post_get_type(), NULL))

/* a function for creating a new object of our type */
#include <stdarg.h>
static TaskPost * GET_NEW_VARG (const char *first, ...) G_GNUC_UNUSED;
static TaskPost *
GET_NEW_VARG (const char *first, ...)
{
	TaskPost *ret;
	va_list ap;
	va_start (ap, first);
	ret = (TaskPost *)g_object_new_valist (task_post_get_type (), first, ap);
	va_end (ap);
	return ret;
}


static void
___dispose (GObject *obj_self)
{
#define __GOB_FUNCTION__ ":Task:Post::dispose"
	TaskPost *self G_GNUC_UNUSED = TASK_POST (obj_self);
	if (G_OBJECT_CLASS (parent_class)->dispose) \
		(* G_OBJECT_CLASS (parent_class)->dispose) (obj_self);
#line 170 "pan/pan/task-post.gob"
	if(self->message) { g_object_unref ((gpointer) self->message); self->message = NULL; }
#line 266 "task-post.c"
}
#undef __GOB_FUNCTION__

static void 
task_post_init (TaskPost * o G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Task:Post::init"
#line 30 "pan/pan/task-post.gob"
	o->message = NULL;
#line 276 "task-post.c"
}
#undef __GOB_FUNCTION__
static void 
task_post_class_init (TaskPostClass * c G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ ":Task:Post::class_init"
	GObjectClass *g_object_class G_GNUC_UNUSED = (GObjectClass*) c;

	parent_class = g_type_class_ref (TYPE_TASK);

	g_object_class->dispose = ___dispose;
}
#undef __GOB_FUNCTION__



#line 172 "pan/pan/task-post.gob"
static void 
task_post_describe (const StatusItem * status, char * buf, int len)
#line 296 "task-post.c"
{
#define __GOB_FUNCTION__ ":Task:Post::describe"
{
#line 173 "pan/pan/task-post.gob"
	
		g_snprintf(buf, len, _("Posting article \"%s\""),
	            g_mime_message_get_subject(TASK_POST(status)->message));
	}}
#line 305 "task-post.c"
#undef __GOB_FUNCTION__

#line 178 "pan/pan/task-post.gob"
static void 
task_post_ran (GIOChannel * channel, TaskStateEnum val, gpointer user_data)
#line 311 "task-post.c"
{
#define __GOB_FUNCTION__ ":Task:Post::ran"
{
#line 179 "pan/pan/task-post.gob"
	
		Task * task = TASK(user_data);
		GMimeMessage * mime_message = TASK_POST(task)->message;
		const char * subject = g_mime_message_get_subject(mime_message);
		GPtrArray *folders=vserver_get_groups(VSERVER_FOLDERS);
		Group *ps, *psl;
		int i;
		for(i=0;i<folders->len;++i)
		{
			Group *g=GROUP(g_ptr_array_index(folders,i));
			if(g->quark=PAN_SENT())
				ps=g;
			if(g->quark=PAN_SENDLATER())
				psl=g;
		}
		
		if (val==TASK_OK)
		{
			log_add_va(LOG_INFO, _("Article \"%s\" posted."), subject);
			
			g_mime_object_remove_header(GMIME_OBJECT(mime_message), PAN_NEWSGROUPS);
			
			folder_remove_message(psl, mime_message);
			folder_add_message(ps, mime_message);
		}
		else
		{
			GString * text;
	
			log_add_va(LOG_ERROR, _("Article \"%s\" not posted."), subject);
	
			/* write the message back to pan.sendlater, because PAN_NEWSGROUPS may have been cleared */
			folder_add_message(psl, mime_message);
	
				text = g_string_new(NULL);
			g_string_append(text, _("Usenet posting failed.  "));
			g_string_append(text, _("Check Tools|Log Viewer for more information.  "));
			g_string_append(text, _("Your message was saved in the folder \"pan.sendlater\""));
			log_add(LOG_ERROR|LOG_URGENT, text->str);
	
			g_string_free(text, TRUE);
		}
	
		group_update_counts(ps);
		group_update_counts(psl);
		g_ptr_array_foreach(folders,pan_g_ptr_array_unref,NULL);
		/* update the task state */
		if (val == TASK_OK)
			task_state_set_work_completed(&task->state);
		else
			task_state_set_work_need_socket(&task->state, task_get_server(task), task_post_run);
		task_state_set_health(&task->state, val);
		task_checkin_socket(task, channel, val==TASK_OK);
	
		debug_exit("task_post_run");
	}}
#line 372 "task-post.c"
#undef __GOB_FUNCTION__

#line 236 "pan/pan/task-post.gob"
static void 
task_post_run (Task * task, GIOChannel * channel)
#line 378 "task-post.c"
{
#define __GOB_FUNCTION__ ":Task:Post::run"
{
#line 237 "pan/pan/task-post.gob"
	
		GMimeMessage * mime_message = TASK_POST(task)->message;
		const char * subject = g_mime_message_get_subject(mime_message);
		char * postme = build_nntp_message(mime_message);
	
		status_item_emit_status_va(STATUS_ITEM(task), _("Posting article \"%s\""), subject);
	
		nntp_post(channel,
				   postme,
				   task_post_ran,
				   task);
	
		task_state_set_work_working(&task->state);
	
		g_free(postme);
	}}
#line 399 "task-post.c"
#undef __GOB_FUNCTION__

#line 254 "pan/pan/task-post.gob"
TaskPost * 
task_post_new (Server * server, GMimeMessage * message)
#line 405 "task-post.c"
{
#define __GOB_FUNCTION__ ":Task:Post::new"
#line 254 "pan/pan/task-post.gob"
	g_return_val_if_fail (server != NULL, (TaskPost * )0);
#line 254 "pan/pan/task-post.gob"
	g_return_val_if_fail (message != NULL, (TaskPost * )0);
#line 254 "pan/pan/task-post.gob"
	g_return_val_if_fail (GMIME_IS_MESSAGE (message), (TaskPost * )0);
#line 414 "task-post.c"
{
#line 255 "pan/pan/task-post.gob"
	
		Self * post = NULL;
		GPtrArray *s;
		debug_enter("task_post_new");
	
		/* sanity clause */
		g_return_val_if_fail(server_is_valid(server), NULL);
	
		/* create the object */
		s=g_ptr_array_sized_new(1);
		g_ptr_array_add(s,server);
		post = g_new0(TaskPost, 1);
		debug1(DEBUG_PAN_OBJECT, "task_post_new: %p", post);
	
		/* initialize the parent class */
		task_constructor(TASK(post),
						  TASK_TYPE_POST,
						  self_describe,
						  s,
						  TRUE);
		task_state_set_work_need_socket(&TASK(post)->state, server, task_post_run);
	
		/* initialize the task-post */
		post->message = message;
		g_object_ref(message);
	
		debug_exit("task_post_new");
		return (post);
	}}
#line 446 "task-post.c"
#undef __GOB_FUNCTION__

#line 302 "pan/pan/task-post.gob"

/****
*****
*****   UTILITIES
*****
****/

static void message_checked_cb(Server        * server,
                    GMimeMessage  * message,
                    GoodnessLevel   goodness,
                    gpointer        user_data)
{
	Task * task = NULL;

	if (goodness == OKAY)
		task = TASK (task_post_new(server, message));
	if (task != NULL)
		queue_add(task);
}

void queue_message_for_posting(Server          * server,
                           GMimeMessage    * message,
                           gboolean          message_check_first)
{
	/* sanity check */
	g_return_if_fail(server_is_valid (server));
	g_return_if_fail(GMIME_IS_MESSAGE (message));

	/* if desired, make sure the message is okay. */
	if (message_check_first)
		message_check_and_prompt(Pan.window, server, message, message_checked_cb, NULL);
	else
		message_checked_cb(server, message, OKAY, NULL);
}

static void flush_sendlater_foreach(GMimeMessage * message, gpointer user_data)
{
	/* find the server that we're posting with */
	Server * server = NULL;
	const char * server_name = g_mime_message_get_header(message, PAN_SERVER);
	if (is_nonempty_string(server_name))
	{
		GQuark server_quark = g_quark_from_string(server_name);
		server = serverlist_get_server(server_quark);
	}
	// FIXME: this should be replaced with something
	//if (server == NULL)
	//	server = serverlist_get_active_server();

	/* queue the message */
	queue_message_for_posting(server, message, TRUE);
}

void flush_sendlater_messages(void)
{
	acache_path_foreach(g_quark_to_string(PAN_SENDLATER()),
                             flush_sendlater_foreach,
                             NULL);
}


#line 511 "task-post.c"
