/* Generated by GOB (v2.0.12)   (do not edit directly) */



/*
 * Pan - A Newsreader for Gtk+
 * Copyright (C) 2004  K. Haley <haleykd@users.sourceforge.net>
 * Copyright (C) 2002  Charles Kerr <charles@rebelbase.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __TASK_H__
#define __TASK_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <pan/base/status-item.h>
#include <pan/base/article.h>

#include <pan/task-state.h>

#ifndef __TYPEDEF_SERVER__
#define __TYPEDEF_SERVER__
typedef struct _Server Server;
#endif

#ifndef __TYPEDEF_TASK__
#define __TYPEDEF_TASK__
typedef struct _Task Task;
#endif

typedef int (*TaskRunFunc)(Task*);

typedef void (*TaskSocketCheckinFunc)(Task          * task,
                                      GIOChannel    * channel,
                                      gboolean        channel_ok,
                                      gpointer        user_data);

typedef void (TaskForallArticlesFunc)(Task     * task,
									  Article  **articles,
									  int      article_qty,
									  gpointer user_data);


typedef enum {
	TASK_TYPE_OTHER,
	TASK_TYPE_BODY,
	TASK_TYPE_BODIES,
	TASK_TYPE_HEADERS,
	TASK_TYPE_SAVE,
	TASK_TYPE_POST
} TaskType;
#define TASK_TYPE_TYPE task_type_get_type()
GType task_type_get_type (void);


/*
 * Type checking and casting macros
 */
#define TYPE_TASK	(task_get_type())
#define TASK(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), task_get_type(), Task)
#define TASK_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), task_get_type(), Task const)
#define TASK_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), task_get_type(), TaskClass)
#define IS_TASK(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), task_get_type ())

#define TASK_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), task_get_type(), TaskClass)

/* Private structure type */
typedef struct _TaskPrivate TaskPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_TASK__
#define __TYPEDEF_TASK__
typedef struct _Task Task;
#endif
struct _Task {
	StatusItem __parent__;
	/*< public >*/
	int thread_qty;
	gboolean abort_flag;
	TaskType type;
	gint8 high_priority:1;
	TaskState state;
	gpointer user_data;
	GPtrArray * articles;
	/*< private >*/
	TaskPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _TaskClass TaskClass;
struct _TaskClass {
	StatusItemClass __parent__;
	/*signal*/void (* ran) (Task * self, gint32 status);
};


/*
 * Public methods
 */
GType	task_get_type	(void);
void 	task_ran	(Task * self,
					gint32 status);
void 	task_add_articles	(Task * self,
					Article ** articles,
					int article_qty);
Server * 	task_get_server	(Task const * self);
gboolean 	task_next_server	(Task * self);
void 	task_give_socket	(Task * self,
					GIOChannel * channel,
					TaskSocketCheckinFunc checkin_func,
					gpointer checkin_data);
void 	task_checkin_socket	(Task * self,
					GIOChannel * channel,
					gboolean channel_ok);
void 	task_work_gui	(Task * self);
void 	task_work_child	(Task * self);
gulong 	task_get_xfer_rate_KiBps	(Task const * self);
void 	task_forall_articles	(Task * self,
					TaskForallArticlesFunc forall_func,
					gpointer forall_user_data);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define task_connect__ran(object,func,data)	g_signal_connect(TASK(__extension__ ({Task *___object = (object); ___object; })),"ran",(GCallback) __extension__ ({void (* ___ran) (Task * ___fake___self, gint32 ___fake___status, gpointer ___data ) = (func); ___ran; }), (data))
#define task_connect_after__ran(object,func,data)	g_signal_connect_after(TASK(__extension__ ({Task *___object = (object); ___object; })),"ran",(GCallback) __extension__ ({void (* ___ran) (Task * ___fake___self, gint32 ___fake___status, gpointer ___data ) = (func); ___ran; }), (data))
#define task_connect_data__ran(object,func,data,destroy_data,flags)	g_signal_connect_data(TASK(__extension__ ({Task *___object = (object); ___object; })),"ran",(GCallback) __extension__ ({void (* ___ran) (Task * ___fake___self, gint32 ___fake___status, gpointer ___data ) = (func); ___ran; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define task_connect__ran(object,func,data)	g_signal_connect(TASK(object),"ran",(GCallback)(func),(data))
#define task_connect_after__ran(object,func,data)	g_signal_connect_after(TASK(object),"ran",(GCallback)(func),(data))
#define task_connect_data__ran(object,func,data,destroy_data,flags)	g_signal_connect_data(TASK(object),"ran",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
