#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <glib.h>


#include <pan/base/base-prefs.h>
#include <pan/base/util-file.h>
#include <pan/base/vserver.h>
#include <pan/base/group.h>
#include <pan/base/db.h>
#include <pan/base/debug.h>
#include <gmime/gmime.h>
#include <pan/base/pan-base-signals.h>

static void
init_pan (void)
{
	base_prefs_init (g_get_tmp_dir(), 100, FALSE, FALSE);
}


int
main (void)
{
	GTimer *timer;
	GPtrArray *groups;
	gulong x;
	const char *name;
	
	g_mime_init(0); // needed because db creation may use it
	//set_debug_level(DEBUG_TRACE);
	timer=g_timer_new();
	g_timer_start(timer);
	init_pan();
	g_timer_stop(timer);
	g_message("Imported data in %.3f seconds.\n",g_timer_elapsed(timer,&x));
	
	vserver_init();
	groups=vserver_get_groups(3);
	int i;
	g_print("folders\n");
	for(i=0;i<groups->len;++i)
	{
		Group *g=GROUP(g_ptr_array_index(groups,i));
		name=group_get_name(g)->str;
		name=name?name:"unknown error";
		g_print("unread: %4d total: %4d %s\n",g->article_qty-g->article_read_qty,g->article_qty,name);
		g_object_unref(g);
	}
	g_ptr_array_free(groups,TRUE);
	groups=vserver_get_groups(1);
	g_print("subscribed\n");
	for(i=0;i<groups->len;++i)
	{
		Group *g=GROUP(g_ptr_array_index(groups,i));
		name=group_get_name(g)->str;
		name=name?name:"unknown error";
		g_print("unread: %4d total: %4d %s\n",g->article_qty-g->article_read_qty,g->article_qty,name);
		g_object_unref(g);
	}
	g_ptr_array_free(groups,TRUE);
	vserver_shutdown();
	pan_base_signals_shutdown(pan_base_signals_get());
	close_db();
	g_timer_destroy(timer);
	return 0;
}
